/// <reference types="react" />
import React, { Ref } from 'react';

declare type WidgetData = any;
interface TextNode {
    type: string;
    children: any[];
}
declare type WidgetRenderer = (params: WidgetRenderParams) => React.ReactElement;
interface WidgetRenderParams {
    data: WidgetData;
    setData?: (WidgetData: any) => void;
    attributes?: any;
    children?: any;
}
declare type EditorData = TextNode[];

declare class EditorController {
    editor: any;
    constructor(editor: any);
    focus(): void;
}

interface Props$1 {
    value: EditorData;
    setValue: (value: EditorData) => void;
    controllerRef: Ref<EditorController>;
}
declare const GoleryEditor: ({ value, setValue, controllerRef }: Props$1) => JSX.Element;
//# sourceMappingURL=GoleryEditor.d.ts.map

interface Props {
    value: TextNode[];
    customRender?: WidgetRenderer;
}
/** Render text editor value as read only content.
 * Here, we don't use the Slate for render, just manually iterate through the value tree and render each of them
 * recursively */
declare const EditorReadOnly: ({ value }: Props) => JSX.Element;
//# sourceMappingURL=EditorReadOnly.d.ts.map

export { EditorController, EditorData, EditorReadOnly, GoleryEditor };
