import * as React from 'react';
import React__default, { useCallback, useRef, useState, useEffect, useMemo } from 'react';
import * as ReactDOM from 'react-dom';
import { useSelected, useFocused, ReactEditor, useSlate, Editable, withReact, Slate } from 'slate-react';
import { Range, Transforms, Editor, Element as Element$1, createEditor } from 'slate';
import { withHistory } from 'slate-history';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$9 = ".EditorModal-module_fullScreen__qvFA0 {\n  padding: 0;\n  margin: 0;\n  box-sizing: border-box;\n  position: fixed;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: rgba(0, 0, 0, 0.4); }\n\n.EditorModal-module_dialog__3Jsms {\n  max-height: 80%;\n  overflow-y: auto;\n  min-width: 30%;\n  padding: 1.5rem;\n  background-color: #fff;\n  border-radius: 4px;\n  box-shadow: 0 2px 26px rgba(0, 0, 0, 0.3), 0 0 0 1px rgba(0, 0, 0, 0.1);\n  display: flex;\n  flex-direction: column;\n  position: relative; }\n  .EditorModal-module_dialog__3Jsms .EditorModal-module_closeButton__1EKeT {\n    display: inline-block;\n    position: absolute;\n    right: 0.5rem;\n    top: 0.5rem;\n    color: gray; }\n  .EditorModal-module_dialog__3Jsms .EditorModal-module_header__1hY2Z {\n    font-weight: bold;\n    margin-bottom: 1rem; }\n  .EditorModal-module_dialog__3Jsms .EditorModal-module_body__33PRv {\n    display: flex;\n    flex-direction: column; }\n  .EditorModal-module_dialog__3Jsms .EditorModal-module_footer__-t62W {\n    text-align: left; }\n    .EditorModal-module_dialog__3Jsms .EditorModal-module_footer__-t62W button {\n      font-size: 1rem;\n      margin-right: 0.5rem;\n      border: 0;\n      padding: 0.5rem;\n      border-radius: 3px;\n      color: white;\n      background-color: #17bd17;\n      min-width: 5rem; }\n    .EditorModal-module_dialog__3Jsms .EditorModal-module_footer__-t62W button:hover {\n      background-color: #fff;\n      border: 1px solid #17bd17;\n      color: #17bd17;\n      cursor: pointer; }\n  .EditorModal-module_dialog__3Jsms input[type='text'] {\n    padding: 6px 10px;\n    outline: 0;\n    border: 1px solid #dbdbdb;\n    margin-bottom: 1rem;\n    transition: border-color 0.15s; }\n  .EditorModal-module_dialog__3Jsms input:focus {\n    color: #303030;\n    background-color: #fff;\n    border-color: #80bdff;\n    outline: 0;\n    box-shadow: 0 0 0 0.2rem rgba(0, 123, 255, 0.25); }\n";
var styles$8 = {"fullScreen":"EditorModal-module_fullScreen__qvFA0","dialog":"EditorModal-module_dialog__3Jsms","closeButton":"EditorModal-module_closeButton__1EKeT","header":"EditorModal-module_header__1hY2Z","body":"EditorModal-module_body__33PRv","footer":"EditorModal-module_footer__-t62W"};
styleInject(css_248z$9);

function CloseIcon(props) {
    return (React.createElement("svg", __assign({ style: {
            width: 24,
            height: 24,
        }, viewBox: "0 0 24 24" }, props),
        React.createElement("path", { fill: "currentColor", d: "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z" })));
}

var EditorModal = function (_a) {
    var onCancel = _a.onCancel, children = _a.children;
    return (React.createElement("div", { className: styles$8.fullScreen },
        React.createElement("div", { className: styles$8.dialog },
            React.createElement("div", { className: styles$8.closeButton, onClick: useCallback(function () { return onCancel(); }, []) },
                React.createElement(CloseIcon, null)),
            children)));
};
var DialogFooter = function (_a) {
    var children = _a.children;
    return (React.createElement("div", { className: styles$8.footer }, children));
};

var ModalTemplate;
(function (ModalTemplate) {
    ModalTemplate["dialog"] = "dialog";
})(ModalTemplate || (ModalTemplate = {}));
function showModal(_a) {
    var getBody = _a.getBody, template = _a.template;
    return new Promise(function (resolve) {
        var keyListener = function (event) {
            if (event.key === 'Escape') {
                closeModal(undefined);
                event.preventDefault();
                event.stopPropagation();
            }
        };
        var elm = document.createElement('div');
        document.body.appendChild(elm);
        var closeModal = function (result) {
            document.removeEventListener('keyup', keyListener);
            ReactDOM.unmountComponentAtNode(elm);
            elm.remove();
            resolve(result);
        };
        document.addEventListener('keyup', keyListener);
        var children = getBody({ closeModal: closeModal });
        var fullScreen = template === ModalTemplate.dialog ? React.createElement(EditorModal, { onCancel: function () { return closeModal(undefined); } }, children) :
            children;
        ReactDOM.render(fullScreen, elm);
    });
}

var css_248z$8 = ".ImageEditor-module_component__2LJDp {\n  min-width: 20rem;\n  min-height: 20rem; }\n\n.ImageEditor-module_textControlV__2zWz5 {\n  font-size: 40px; }\n\n.ImageEditor-module_textPasteFromClipboard__ldTVS {\n  font-size: 16px;\n  margin-top: 1rem; }\n\n.ImageEditor-module_textPaste__2TjMo {\n  color: green; }\n\n.ImageEditor-module_igmurWarning__3RvEN {\n  color: #bf0000;\n  max-width: 600px; }\n\n.ImageEditor-module_button__2Wcm3 {\n  display: inline-block;\n  font-size: 14px;\n  height: 30px;\n  line-height: 30px;\n  text-align: center;\n  background-color: #fc9;\n  margin-bottom: 1rem;\n  margin-top: 0.5rem;\n  padding: 0 1rem;\n  margin-right: 1rem; }\n\n.ImageEditor-module_button__2Wcm3:hover {\n  background-color: #f96;\n  color: #fff; }\n\n.ImageEditor-module_spinnerHolder__3WQzD {\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: 0;\n  right: 0;\n  opacity: .9;\n  background-color: #eee; }\n\n.ImageEditor-module_spinnerHolder__3WQzD .ImageEditor-module_spinner__1iok7 {\n  position: absolute;\n  left: 50%;\n  top: 50%; }\n\n.ImageEditor-module_resizeSlider__3Qero {\n  display: inline-block; }\n";
var styles$7 = {"component":"ImageEditor-module_component__2LJDp","textControlV":"ImageEditor-module_textControlV__2zWz5","textPasteFromClipboard":"ImageEditor-module_textPasteFromClipboard__ldTVS","textPaste":"ImageEditor-module_textPaste__2TjMo","igmurWarning":"ImageEditor-module_igmurWarning__3RvEN","button":"ImageEditor-module_button__2Wcm3","spinnerHolder":"ImageEditor-module_spinnerHolder__3WQzD","spinner":"ImageEditor-module_spinner__1iok7","resizeSlider":"ImageEditor-module_resizeSlider__3Qero"};
styleInject(css_248z$8);

var ClipboardUtils = /** @class */ (function () {
    function ClipboardUtils() {
    }
    ClipboardUtils.getFirstImageBlobUrl = function (e) {
        var clipboardData = e.clipboardData;
        if (clipboardData === null) {
            console.log('No clipboard data');
            return null;
        }
        var items = clipboardData.items;
        for (var i = 0; i < items.length; ++i) {
            if (items[i].kind == 'file' &&
                items[i].type.indexOf('image/') !== -1) {
                var blob = items[i].getAsFile();
                window.URL = window.URL || window.webkitURL;
                return window.URL.createObjectURL(blob);
            }
        }
    };
    return ClipboardUtils;
}());

var GoApi = /** @class */ (function () {
    function GoApi() {
        this.baseUrl = 'http://www.golery.com:8200';
    }
    GoApi.prototype.uploadImage = function (blob) {
        return __awaiter(this, void 0, void 0, function () {
            var url, formData, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.baseUrl + "/api2/file/pencil";
                        formData = new FormData();
                        formData.append('file', blob);
                        return [4 /*yield*/, fetch(url, {
                                method: 'POST', body: formData
                            })];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        json = _a.sent();
                        console.log(json);
                        return [2 /*return*/, json];
                }
            });
        });
    };
    GoApi.prototype.getFileUrl = function (key) {
        return this.baseUrl + "/api2/file/" + key;
    };
    return GoApi;
}());
var goApi = new GoApi();

var MAX_IMAGE_WIDTH = 1000;
var MAX_IMAGE_HEIGHT = 800;
var ImageEditor = function (_a) {
    var closeDialog = _a.closeDialog;
    var imageRef = useRef(new Image());
    var _b = __read(useState(false), 2), hasImage = _b[0], setHasImage = _b[1];
    var _c = __read(useState(false), 2), showSpinner = _c[0], setShowSpinner = _c[1];
    var _d = __read(useState(100), 2), resizePercent = _d[0], setResizePercent = _d[1];
    var _e = __read(useState({ width: 0, height: 0 }), 2), imageSize = _e[0], setImageSize = _e[1];
    var onPaste = function () {
    };
    var spinnerClassName = "fa fa-spinner fa-pulse " + styles$7.spinner;
    var elmInner;
    var image = imageRef.current;
    var canvasRef = React.createRef();
    useEffect(function () {
        document.addEventListener('paste', _pasteListener);
        return function () {
            document.removeEventListener('paste', _pasteListener);
        };
    }, [_pasteListener]);
    console.log('Rs', resizePercent);
    function onResize(e) {
        var value = e.target.value;
        setResizePercent(parseFloat(value));
    }
    function _pasteListener(e) {
        e.stopPropagation();
        e.preventDefault();
        var blobUrl = ClipboardUtils.getFirstImageBlobUrl(e);
        if (!blobUrl) {
            return;
        }
        _copyToCanvas(blobUrl);
    }
    // http://stackoverflow.com/questions/18377891/how-can-i-let-user-paste-image-data-from-the-clipboard-into-a-canvas-element-in
    function _copyToCanvas(objectUrl) {
        var canvas = canvasRef.current;
        image.onload = function () {
            var size = _adjustImageSize(image.width, image.height);
            setHasImage(true);
            setImageSize(size);
            console.log('Resize to', size);
            if (!!canvas) {
                canvas.width = size.width;
                canvas.height = size.height;
            }
        };
        image.src = objectUrl;
    }
    useEffect(function () {
        if (!image.src || !image.complete)
            return;
        var canvas = canvasRef.current;
        if (!canvas)
            return;
        var ratio = resizePercent / 100.0;
        var size = _adjustImageSize(image.width, image.height);
        size = { width: size.width * ratio, height: size.height * ratio };
        canvas.width = size.width;
        canvas.height = size.height;
        var ctx = canvas.getContext("2d");
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        console.log(image.width, image.height, 0, 0, canvas.width, canvas.height);
        ctx.drawImage(image, 0, 0, image.width, image.height, 0, 0, canvas.width, canvas.height);
    }, [image.src, image.complete, canvasRef.current, resizePercent]);
    function _adjustImageSize(width, height) {
        var ratio = width / height;
        var w = width;
        var h = height;
        if (w >= MAX_IMAGE_WIDTH) {
            w = 1000;
            h = w / ratio;
        }
        if (h >= MAX_IMAGE_HEIGHT) {
            h = 800;
            w = h * ratio;
        }
        return { width: w, height: h };
    }
    function uploadImage() {
        return __awaiter(this, void 0, void 0, function () {
            var canvas;
            return __generator(this, function (_a) {
                canvas = canvasRef.current;
                setShowSpinner(true);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        canvas.toBlob(function (blob) {
                            resolve(blob);
                        });
                    }).then(function (blob) {
                        return goApi.uploadImage(blob);
                    }).then(function (_a) {
                        var key = _a.key;
                        closeDialog({ key: key });
                    })];
            });
        });
    }
    if (hasImage) {
        var canvassHolderStyle = imageSize;
        elmInner = React.createElement("div", null,
            React.createElement("div", null,
                React.createElement("div", { className: styles$7.button, onClick: uploadImage },
                    React.createElement("i", { className: "fa fa-cloud-upload" }),
                    "UPLOAD"),
                React.createElement("input", { className: styles$7.resizeSlider, type: "range", value: resizePercent, onChange: function (e) { return onResize(e); } })),
            React.createElement("div", { style: canvassHolderStyle },
                React.createElement("canvas", { ref: canvasRef })));
    }
    else {
        elmInner = React.createElement("div", null,
            React.createElement("div", { className: styles$7.textControlV }, "Ctrl + V"),
            React.createElement("div", { className: styles$7.textPasteFromClipboard },
                React.createElement("span", { className: styles$7.textPaste }, "Paste"),
                " from your clipboard."));
    }
    var elmSpinner = showSpinner &&
        React.createElement("div", { className: styles$7.spinnerHolder },
            React.createElement("i", { className: spinnerClassName }));
    return React.createElement("div", { className: styles$7.component, onPaste: onPaste },
        elmInner,
        elmSpinner);
};

var css_248z$7 = ".ImageView-module_zoomButton__2BG09 {\n  position: absolute;\n  right: 0;\n  top: 0;\n  padding: 0.5rem;\n  margin: 0.5rem;\n  border-radius: 3px;\n  visibility: hidden;\n  cursor: pointer; }\n\n.ImageView-module_imageHolder__3rT8u:hover .ImageView-module_zoomButton__2BG09 {\n  background-color: #FFFFFF88;\n  visibility: visible; }\n\n.ImageView-module_imageHolder__3rT8u {\n  display: inline-block;\n  position: relative; }\n";
var styles$6 = {"zoomButton":"ImageView-module_zoomButton__2BG09","imageHolder":"ImageView-module_imageHolder__3rT8u"};
styleInject(css_248z$7);

var css_248z$6 = ".ImageViewFullScreen-module_component__3j1j5 {\n  background-color: black;\n  position: fixed;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  display: flex;\n  justify-content: center;\n  align-items: center; }\n  .ImageViewFullScreen-module_component__3j1j5 img {\n    border-radius: 2px; }\n\n.ImageViewFullScreen-module_closeButton__UqVtL {\n  display: inline-block;\n  position: absolute;\n  right: 0.5rem;\n  top: 0.5rem;\n  color: gray; }\n";
var styles$5 = {"component":"ImageViewFullScreen-module_component__3j1j5","closeButton":"ImageViewFullScreen-module_closeButton__UqVtL"};
styleInject(css_248z$6);

/** Show image in full screen view */
var ImageViewFullScreen = function (_a) {
    var url = _a.url, closeDialog = _a.closeDialog;
    return (React__default.createElement("div", { className: styles$5.component },
        React__default.createElement("div", null,
            React__default.createElement("img", { src: url }),
            React__default.createElement("div", { className: styles$5.closeButton, onClick: function () { return closeDialog(); } },
                React__default.createElement(CloseIcon, null)))));
};

var ImageView = function (_a) {
    var url = _a.url;
    if (!url)
        return React__default.createElement("span", null, "(missing url)");
    var onFullScreen = function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, showModal({
                        getBody: function (_a) {
                            var closeModal = _a.closeModal;
                            return React__default.createElement(ImageViewFullScreen, { closeDialog: closeModal, url: url });
                        }
                    })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); };
    return (React__default.createElement("div", null,
        React__default.createElement("div", { className: styles$6.imageHolder },
            React__default.createElement("img", { src: url, alt: url }),
            React__default.createElement("div", { className: styles$6.zoomButton, onClick: onFullScreen }, "[\u00A0 ]"))));
};

/** This file contains description of data of widgets inside editor */
/** Text format */
var TYPE_H1 = 'h1';
var TYPE_H2 = 'h2';
var TYPE_H3 = 'h3';
var TYPE_NUMBERED_LIST = 'ol';
var TYPE_BULLETED_LIST = 'ul';
var TYPE_LIST_ITEM = 'li';
/** Leaf format */
var MARK_ITALIC = 'italic';
var MARK_UNDERLINE = 'underline';
var MARK_BOLD = 'bold';
/** Each element in slate js has a type and render engine renders element based on that type */
var TYPE_PARAGRAPH = 'p';
var TYPE_CODE = 'code';
var TYPE_IMAGE = 'image';
var TYPE_LINK = 'link';

var css_248z$5 = ".ImageEdit-module_selected__bGwiV {\n  box-shadow: 0 0 0 3px #B4D5FF; }\n";
var styles$4 = {"selected":"ImageEdit-module_selected__bGwiV"};
styleInject(css_248z$5);

var ImageEdit = function (_a) {
    var url = _a.url;
    var selected = useSelected();
    var focused = useFocused();
    if (!url)
        return React__default.createElement("span", null, "(missing url)");
    return (React__default.createElement("img", { contentEditable: false, src: url, alt: url, className: selected && focused ? styles$4.selected : '' }));
};

function getImageUrl(src) {
    if (!src)
        return;
    var _a = src[0], key = _a.key, url = _a.url;
    if (url)
        return url;
    return goApi.getFileUrl(key);
}
var ImagePlugin = {
    id: 'image',
    init: function (_a) {
        var editor = _a.editor;
        editor.voidElements.push(TYPE_IMAGE);
    },
    renderEdit: function (_a) {
        var data = _a.data, attributes = _a.attributes, children = _a.children;
        var _b = data, type = _b.type, src = _b.src;
        if (type === TYPE_IMAGE) {
            var url = getImageUrl(src);
            return url ? React__default.createElement("div", __assign({}, attributes),
                React__default.createElement(ImageEdit, { url: url }),
                children) : React__default.createElement("span", null);
        }
    },
    renderView: function (_a) {
        var data = _a.data, attributes = _a.attributes;
        var _b = data, type = _b.type, src = _b.src;
        if (type === TYPE_IMAGE) {
            var url = getImageUrl(src);
            return React__default.createElement(ImageView, __assign({ url: url }, (attributes || {})));
        }
    },
    onInsert: function () {
        return __awaiter(this, void 0, void 0, function () {
            var key;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, showModal({
                            getBody: function (_a) {
                                var closeModal = _a.closeModal;
                                return React__default.createElement(ImageEditor, { closeDialog: closeModal });
                            },
                            template: ModalTemplate.dialog
                        })];
                    case 1:
                        key = (_a.sent()).key;
                        return [2 /*return*/, {
                                type: 'image',
                                src: [{ key: key }]
                            }];
                }
            });
        });
    }
};

var css_248z$4 = ".CodeEditor-module_code__1Q1Lu {\n  min-height: 15rem;\n  padding: 1rem;\n  border: 1px solid #ccc;\n  border-left: 10px solid darkgreen;\n  width: calc(100% - 3rem);\n  outline: none;\n  margin-top: 1.2rem;\n  margin-bottom: 1rem; }\n";
var styles$3 = {"code":"CodeEditor-module_code__1Q1Lu"};
styleInject(css_248z$4);

var CodeEditor = function (_a) {
    var code = _a.code, onSave = _a.onSave;
    var _b = __read(useState(''), 2), editingCode = _b[0], setEditingCode = _b[1];
    var _c = __read(useState(false), 2), dirty = _c[0], setDirty = _c[1];
    var onClick = useCallback(function () { onSave(editingCode); }, [editingCode]);
    var onChange = useCallback(function (e) {
        setDirty(true);
        setEditingCode(e.target.value);
    }, []);
    var displayCode = dirty ? editingCode : code;
    return (React.createElement("div", null,
        React.createElement("textarea", { className: styles$3.code, value: displayCode, onChange: onChange, placeholder: 'Paste code here' }),
        React.createElement(DialogFooter, null,
            React.createElement("button", { onClick: onClick }, "SAVE"))));
};

var css_248z$3 = "/**\n * Coldark Theme for Prism.js\n * Theme variation: Dark\n * Tested with HTML, CSS, JS, JSON, PHP, YAML, Bash script\n * @author Armand Philippot <contact@armandphilippot.com>\n * @homepage https://github.com/ArmandPhilippot/coldark-prism\n * @license MIT\n */\ncode[class*=\"language-\"],\npre[class*=\"language-\"] {\n\tcolor: #e3eaf2;\n\tbackground: none;\n\tfont-family: Consolas, Monaco, \"Andale Mono\", \"Ubuntu Mono\", monospace;\n\ttext-align: left;\n\twhite-space: pre;\n\tword-spacing: normal;\n\tword-break: normal;\n\tword-wrap: normal;\n\tline-height: 1.5;\n\t-moz-tab-size: 4;\n\t-o-tab-size: 4;\n\ttab-size: 4;\n\t-webkit-hyphens: none;\n\t-moz-hyphens: none;\n\t-ms-hyphens: none;\n\thyphens: none;\n}\n\npre[class*=\"language-\"]::-moz-selection,\npre[class*=\"language-\"] ::-moz-selection,\ncode[class*=\"language-\"]::-moz-selection,\ncode[class*=\"language-\"] ::-moz-selection {\n\tbackground: #3c526d;\n}\n\npre[class*=\"language-\"]::selection,\npre[class*=\"language-\"] ::selection,\ncode[class*=\"language-\"]::selection,\ncode[class*=\"language-\"] ::selection {\n\tbackground: #3c526d;\n}\n\n/* Code blocks */\npre[class*=\"language-\"] {\n\tpadding: 1em;\n\tmargin: 0.5em 0;\n\toverflow: auto;\n}\n\n:not(pre) > code[class*=\"language-\"],\npre[class*=\"language-\"] {\n\tbackground: #111b27;\n}\n\n/* Inline code */\n:not(pre) > code[class*=\"language-\"] {\n\tpadding: 0.1em 0.3em;\n\tborder-radius: 0.3em;\n\twhite-space: normal;\n}\n\n.prism_token__B1t07.prism_comment__1M4q9,\n.prism_token__B1t07.prism_prolog__11WWU,\n.prism_token__B1t07.prism_doctype__3j5C8,\n.prism_token__B1t07.prism_cdata__1j-HU {\n\tcolor: #8da1b9;\n}\n\n.prism_token__B1t07.prism_punctuation__2afAk {\n\tcolor: #e3eaf2;\n}\n\n.prism_token__B1t07.prism_delimiter__120tb.prism_important__1j0Ed,\n.prism_token__B1t07.prism_selector__3Rb2p .prism_parent__3KabT,\n.prism_token__B1t07.prism_tag__3iTjW,\n.prism_token__B1t07.prism_tag__3iTjW .prism_token__B1t07.prism_punctuation__2afAk {\n\tcolor: #66cccc;\n}\n\n.prism_token__B1t07.prism_attr-name__4J77d,\n.prism_token__B1t07.prism_boolean__2TlS4,\n.prism_token__B1t07.prism_boolean__2TlS4.prism_important__1j0Ed,\n.prism_token__B1t07.prism_number__BRWhz,\n.prism_token__B1t07.prism_constant__3VV-X,\n.prism_token__B1t07.prism_selector__3Rb2p .prism_token__B1t07.prism_attribute__38PHA {\n\tcolor: #e6d37a;\n}\n\n.prism_token__B1t07.prism_class-name__1eeLi,\n.prism_token__B1t07.prism_key__2ZD3w,\n.prism_token__B1t07.prism_parameter__1OI_R,\n.prism_token__B1t07.prism_property__xTQ5O,\n.prism_token__B1t07.prism_property-access__chxmG,\n.prism_token__B1t07.prism_variable__5Dhiy {\n\tcolor: #6cb8e6;\n}\n\n.prism_token__B1t07.prism_attr-value__3XY2t,\n.prism_token__B1t07.prism_inserted__3hP7h,\n.prism_token__B1t07.prism_color__V8FsA,\n.prism_token__B1t07.prism_selector__3Rb2p .prism_token__B1t07.prism_value__2GMKi,\n.prism_token__B1t07.prism_string__2K0Bc,\n.prism_token__B1t07.prism_string__2K0Bc .prism_token__B1t07.prism_url-link__7G74o {\n\tcolor: #91d076;\n}\n\n.prism_token__B1t07.prism_builtin__1Pmr9,\n.prism_token__B1t07.prism_keyword-array__1AjMU,\n.prism_token__B1t07.prism_package__1Ls1I,\n.prism_token__B1t07.prism_regex__1bpLz {\n\tcolor: #f4adf4;\n}\n\n.prism_token__B1t07.prism_function__3C7tR,\n.prism_token__B1t07.prism_selector__3Rb2p .prism_token__B1t07.prism_class__2KWrg,\n.prism_token__B1t07.prism_selector__3Rb2p .prism_token__B1t07.prism_id__1CBdY {\n\tcolor: #c699e3;\n}\n\n.prism_token__B1t07.prism_atrule__1REKH .prism_token__B1t07.prism_rule__2pPXz,\n.prism_token__B1t07.prism_combinator__1TRzR,\n.prism_token__B1t07.prism_keyword__1T6r5,\n.prism_token__B1t07.prism_operator__2xywf,\n.prism_token__B1t07.prism_pseudo-class__2egnS,\n.prism_token__B1t07.prism_pseudo-element__ebDeZ,\n.prism_token__B1t07.prism_selector__3Rb2p,\n.prism_token__B1t07.prism_unit__18QKB {\n\tcolor: #e9ae7e;\n}\n\n.prism_token__B1t07.prism_deleted__2ae_B,\n.prism_token__B1t07.prism_important__1j0Ed {\n\tcolor: #cd6660;\n}\n\n.prism_token__B1t07.prism_keyword-this__2EZAS,\n.prism_token__B1t07.prism_this__DRJZM {\n\tcolor: #6cb8e6;\n}\n\n.prism_token__B1t07.prism_important__1j0Ed,\n.prism_token__B1t07.prism_keyword-this__2EZAS,\n.prism_token__B1t07.prism_this__DRJZM,\n.prism_token__B1t07.prism_bold__2Sans {\n\tfont-weight: bold;\n}\n\n.prism_token__B1t07.prism_delimiter__120tb.prism_important__1j0Ed {\n\tfont-weight: inherit;\n}\n\n.prism_token__B1t07.prism_italic__3HCoY {\n\tfont-style: italic;\n}\n\n.prism_token__B1t07.prism_entity__3d4cR {\n\tcursor: help;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_title__1YWB3,\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_title__1YWB3 .prism_token__B1t07.prism_punctuation__2afAk {\n\tcolor: #6cb8e6;\n\tfont-weight: bold;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_blockquote__3pGd2.prism_punctuation__2afAk {\n\tcolor: #f4adf4;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_code__3dhYF {\n\tcolor: #66cccc;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_hr__wsk08.prism_punctuation__2afAk {\n\tcolor: #6cb8e6;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_url__cgnWW .prism_token__B1t07.prism_content__3JM1d {\n\tcolor: #91d076;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_url-link__7G74o {\n\tcolor: #e6d37a;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_list__IGX1u.prism_punctuation__2afAk {\n\tcolor: #f4adf4;\n}\n\n.prism_language-markdown__1fOJK .prism_token__B1t07.prism_table-header__1-5i5 {\n\tcolor: #e3eaf2;\n}\n\n.prism_language-json__299ym .prism_token__B1t07.prism_operator__2xywf {\n\tcolor: #e3eaf2;\n}\n\n.prism_language-scss__yTgfw .prism_token__B1t07.prism_variable__5Dhiy {\n\tcolor: #66cccc;\n}\n\n/* overrides color-values for the Show Invisibles plugin\n * https://prismjs.com/plugins/show-invisibles/\n */\n.prism_token__B1t07.prism_tab__3Dt3n:not(:empty):before,\n.prism_token__B1t07.prism_cr__3eg7Y:before,\n.prism_token__B1t07.prism_lf__VaENA:before,\n.prism_token__B1t07.prism_space__1AYeq:before {\n\tcolor: #8da1b9;\n}\n\n/* overrides color-values for the Toolbar plugin\n * https://prismjs.com/plugins/toolbar/\n */\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB a,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB button {\n\tcolor: #111b27;\n\tbackground: #6cb8e6;\n}\n\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB a:hover,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB a:focus,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB button:hover,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB button:focus {\n\tcolor: #111b27;\n\tbackground: #6cb8e6da;\n\ttext-decoration: none;\n}\n\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB span,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB span:hover,\ndiv.prism_code-toolbar__K6Gm2 > .prism_toolbar__EyeaB span:focus {\n\tcolor: #111b27;\n\tbackground: #8da1b9;\n}\n\n/* overrides color-values for the Line Highlight plugin\n * http://prismjs.com/plugins/line-highlight/\n */\n.prism_line-highlight__11jjg {\n\tbackground: #3c526d5f;\n\tbackground: linear-gradient(to right, #3c526d5f 70%, #3c526d55);\n}\n\n.prism_line-highlight__11jjg:before,\n.prism_line-highlight__11jjg[data-end]:after {\n\tbackground-color: #8da1b9;\n\tcolor: #111b27;\n\tbox-shadow: 0 1px #3c526d;\n}\n\npre[id].prism_linkable-line-numbers__125AB span.prism_line-numbers-rows__33cjt > span:hover:before {\n\tbackground-color: #8da1b918;\n}\n\n/* overrides color-values for the Line Numbers plugin\n * http://prismjs.com/plugins/line-numbers/\n */\n.prism_line-numbers__3jurw .prism_line-numbers-rows__33cjt {\n\tborder-right: 1px solid #0b121b;\n\tbackground: #0b121b7a;\n}\n\n.prism_line-numbers-rows__33cjt > span:before {\n\tcolor: #8da1b9da;\n}\n\n/* overrides color-values for the Match Braces plugin\n * https://prismjs.com/plugins/match-braces/\n */\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-1__zpWep,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-5__17Raw,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-9__175fr {\n\tcolor: #e6d37a;\n}\n\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-2__1OSXl,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-6__2-vD4,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-10__159M1 {\n\tcolor: #f4adf4;\n}\n\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-3__3j42g,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-7__24X6y,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-11__1KqKX {\n\tcolor: #6cb8e6;\n}\n\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-4__2f6S_,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-8__BJ_rT,\n.prism_rainbow-braces__2YaF7 .prism_token__B1t07.prism_punctuation__2afAk.prism_brace-level-12__1Cof5 {\n\tcolor: #c699e3;\n}\n\n/* overrides color-values for the Diff Highlight plugin\n * https://prismjs.com/plugins/diff-highlight/\n */\npre.prism_diff-highlight__2B9Dt > code .prism_token__B1t07.prism_deleted__2ae_B:not(.prism_prefix__3ce6e),\npre > code.prism_diff-highlight__2B9Dt .prism_token__B1t07.prism_deleted__2ae_B:not(.prism_prefix__3ce6e) {\n\tbackground-color: #cd66601f;\n}\n\npre.prism_diff-highlight__2B9Dt > code .prism_token__B1t07.prism_inserted__3hP7h:not(.prism_prefix__3ce6e),\npre > code.prism_diff-highlight__2B9Dt .prism_token__B1t07.prism_inserted__3hP7h:not(.prism_prefix__3ce6e) {\n\tbackground-color: #91d0761f;\n}\n\n/* overrides color-values for the Command Line plugin\n * https://prismjs.com/plugins/command-line/\n */\n.prism_command-line-prompt__1Yo8J {\n\tborder-right: 1px solid #0b121b;\n}\n\n.prism_command-line-prompt__1Yo8J > span:before {\n\tcolor: #8da1b9da;\n}";
styleInject(css_248z$3);

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var prism = createCommonjsModule(function (module) {
/* **********************************************
     Begin prism-core.js
********************************************** */

/// <reference lib="WebWorker"/>

var _self = (typeof window !== 'undefined')
	? window   // if in browser
	: (
		(typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope)
			? self // if in worker
			: {}   // if in node js
	);

/**
 * Prism: Lightweight, robust, elegant syntax highlighting
 *
 * @license MIT <https://opensource.org/licenses/MIT>
 * @author Lea Verou <https://lea.verou.me>
 * @namespace
 * @public
 */
var Prism = (function (_self) {

	// Private helper vars
	var lang = /\blang(?:uage)?-([\w-]+)\b/i;
	var uniqueId = 0;

	// The grammar object for plaintext
	var plainTextGrammar = {};


	var _ = {
		/**
		 * By default, Prism will attempt to highlight all code elements (by calling {@link Prism.highlightAll}) on the
		 * current page after the page finished loading. This might be a problem if e.g. you wanted to asynchronously load
		 * additional languages or plugins yourself.
		 *
		 * By setting this value to `true`, Prism will not automatically highlight all code elements on the page.
		 *
		 * You obviously have to change this value before the automatic highlighting started. To do this, you can add an
		 * empty Prism object into the global scope before loading the Prism script like this:
		 *
		 * ```js
		 * window.Prism = window.Prism || {};
		 * Prism.manual = true;
		 * // add a new <script> to load Prism's script
		 * ```
		 *
		 * @default false
		 * @type {boolean}
		 * @memberof Prism
		 * @public
		 */
		manual: _self.Prism && _self.Prism.manual,
		disableWorkerMessageHandler: _self.Prism && _self.Prism.disableWorkerMessageHandler,

		/**
		 * A namespace for utility methods.
		 *
		 * All function in this namespace that are not explicitly marked as _public_ are for __internal use only__ and may
		 * change or disappear at any time.
		 *
		 * @namespace
		 * @memberof Prism
		 */
		util: {
			encode: function encode(tokens) {
				if (tokens instanceof Token) {
					return new Token(tokens.type, encode(tokens.content), tokens.alias);
				} else if (Array.isArray(tokens)) {
					return tokens.map(encode);
				} else {
					return tokens.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/\u00a0/g, ' ');
				}
			},

			/**
			 * Returns the name of the type of the given value.
			 *
			 * @param {any} o
			 * @returns {string}
			 * @example
			 * type(null)      === 'Null'
			 * type(undefined) === 'Undefined'
			 * type(123)       === 'Number'
			 * type('foo')     === 'String'
			 * type(true)      === 'Boolean'
			 * type([1, 2])    === 'Array'
			 * type({})        === 'Object'
			 * type(String)    === 'Function'
			 * type(/abc+/)    === 'RegExp'
			 */
			type: function (o) {
				return Object.prototype.toString.call(o).slice(8, -1);
			},

			/**
			 * Returns a unique number for the given object. Later calls will still return the same number.
			 *
			 * @param {Object} obj
			 * @returns {number}
			 */
			objId: function (obj) {
				if (!obj['__id']) {
					Object.defineProperty(obj, '__id', { value: ++uniqueId });
				}
				return obj['__id'];
			},

			/**
			 * Creates a deep clone of the given object.
			 *
			 * The main intended use of this function is to clone language definitions.
			 *
			 * @param {T} o
			 * @param {Record<number, any>} [visited]
			 * @returns {T}
			 * @template T
			 */
			clone: function deepClone(o, visited) {
				visited = visited || {};

				var clone; var id;
				switch (_.util.type(o)) {
					case 'Object':
						id = _.util.objId(o);
						if (visited[id]) {
							return visited[id];
						}
						clone = /** @type {Record<string, any>} */ ({});
						visited[id] = clone;

						for (var key in o) {
							if (o.hasOwnProperty(key)) {
								clone[key] = deepClone(o[key], visited);
							}
						}

						return /** @type {any} */ (clone);

					case 'Array':
						id = _.util.objId(o);
						if (visited[id]) {
							return visited[id];
						}
						clone = [];
						visited[id] = clone;

						(/** @type {Array} */(/** @type {any} */(o))).forEach(function (v, i) {
							clone[i] = deepClone(v, visited);
						});

						return /** @type {any} */ (clone);

					default:
						return o;
				}
			},

			/**
			 * Returns the Prism language of the given element set by a `language-xxxx` or `lang-xxxx` class.
			 *
			 * If no language is set for the element or the element is `null` or `undefined`, `none` will be returned.
			 *
			 * @param {Element} element
			 * @returns {string}
			 */
			getLanguage: function (element) {
				while (element && !lang.test(element.className)) {
					element = element.parentElement;
				}
				if (element) {
					return (element.className.match(lang) || [, 'none'])[1].toLowerCase();
				}
				return 'none';
			},

			/**
			 * Returns the script element that is currently executing.
			 *
			 * This does __not__ work for line script element.
			 *
			 * @returns {HTMLScriptElement | null}
			 */
			currentScript: function () {
				if (typeof document === 'undefined') {
					return null;
				}
				if ('currentScript' in document && 1 < 2 /* hack to trip TS' flow analysis */) {
					return /** @type {any} */ (document.currentScript);
				}

				// IE11 workaround
				// we'll get the src of the current script by parsing IE11's error stack trace
				// this will not work for inline scripts

				try {
					throw new Error();
				} catch (err) {
					// Get file src url from stack. Specifically works with the format of stack traces in IE.
					// A stack will look like this:
					//
					// Error
					//    at _.util.currentScript (http://localhost/components/prism-core.js:119:5)
					//    at Global code (http://localhost/components/prism-core.js:606:1)

					var src = (/at [^(\r\n]*\((.*):.+:.+\)$/i.exec(err.stack) || [])[1];
					if (src) {
						var scripts = document.getElementsByTagName('script');
						for (var i in scripts) {
							if (scripts[i].src == src) {
								return scripts[i];
							}
						}
					}
					return null;
				}
			},

			/**
			 * Returns whether a given class is active for `element`.
			 *
			 * The class can be activated if `element` or one of its ancestors has the given class and it can be deactivated
			 * if `element` or one of its ancestors has the negated version of the given class. The _negated version_ of the
			 * given class is just the given class with a `no-` prefix.
			 *
			 * Whether the class is active is determined by the closest ancestor of `element` (where `element` itself is
			 * closest ancestor) that has the given class or the negated version of it. If neither `element` nor any of its
			 * ancestors have the given class or the negated version of it, then the default activation will be returned.
			 *
			 * In the paradoxical situation where the closest ancestor contains __both__ the given class and the negated
			 * version of it, the class is considered active.
			 *
			 * @param {Element} element
			 * @param {string} className
			 * @param {boolean} [defaultActivation=false]
			 * @returns {boolean}
			 */
			isActive: function (element, className, defaultActivation) {
				var no = 'no-' + className;

				while (element) {
					var classList = element.classList;
					if (classList.contains(className)) {
						return true;
					}
					if (classList.contains(no)) {
						return false;
					}
					element = element.parentElement;
				}
				return !!defaultActivation;
			}
		},

		/**
		 * This namespace contains all currently loaded languages and the some helper functions to create and modify languages.
		 *
		 * @namespace
		 * @memberof Prism
		 * @public
		 */
		languages: {
			/**
			 * The grammar for plain, unformatted text.
			 */
			plain: plainTextGrammar,
			plaintext: plainTextGrammar,
			text: plainTextGrammar,
			txt: plainTextGrammar,

			/**
			 * Creates a deep copy of the language with the given id and appends the given tokens.
			 *
			 * If a token in `redef` also appears in the copied language, then the existing token in the copied language
			 * will be overwritten at its original position.
			 *
			 * ## Best practices
			 *
			 * Since the position of overwriting tokens (token in `redef` that overwrite tokens in the copied language)
			 * doesn't matter, they can technically be in any order. However, this can be confusing to others that trying to
			 * understand the language definition because, normally, the order of tokens matters in Prism grammars.
			 *
			 * Therefore, it is encouraged to order overwriting tokens according to the positions of the overwritten tokens.
			 * Furthermore, all non-overwriting tokens should be placed after the overwriting ones.
			 *
			 * @param {string} id The id of the language to extend. This has to be a key in `Prism.languages`.
			 * @param {Grammar} redef The new tokens to append.
			 * @returns {Grammar} The new language created.
			 * @public
			 * @example
			 * Prism.languages['css-with-colors'] = Prism.languages.extend('css', {
			 *     // Prism.languages.css already has a 'comment' token, so this token will overwrite CSS' 'comment' token
			 *     // at its original position
			 *     'comment': { ... },
			 *     // CSS doesn't have a 'color' token, so this token will be appended
			 *     'color': /\b(?:red|green|blue)\b/
			 * });
			 */
			extend: function (id, redef) {
				var lang = _.util.clone(_.languages[id]);

				for (var key in redef) {
					lang[key] = redef[key];
				}

				return lang;
			},

			/**
			 * Inserts tokens _before_ another token in a language definition or any other grammar.
			 *
			 * ## Usage
			 *
			 * This helper method makes it easy to modify existing languages. For example, the CSS language definition
			 * not only defines CSS highlighting for CSS documents, but also needs to define highlighting for CSS embedded
			 * in HTML through `<style>` elements. To do this, it needs to modify `Prism.languages.markup` and add the
			 * appropriate tokens. However, `Prism.languages.markup` is a regular JavaScript object literal, so if you do
			 * this:
			 *
			 * ```js
			 * Prism.languages.markup.style = {
			 *     // token
			 * };
			 * ```
			 *
			 * then the `style` token will be added (and processed) at the end. `insertBefore` allows you to insert tokens
			 * before existing tokens. For the CSS example above, you would use it like this:
			 *
			 * ```js
			 * Prism.languages.insertBefore('markup', 'cdata', {
			 *     'style': {
			 *         // token
			 *     }
			 * });
			 * ```
			 *
			 * ## Special cases
			 *
			 * If the grammars of `inside` and `insert` have tokens with the same name, the tokens in `inside`'s grammar
			 * will be ignored.
			 *
			 * This behavior can be used to insert tokens after `before`:
			 *
			 * ```js
			 * Prism.languages.insertBefore('markup', 'comment', {
			 *     'comment': Prism.languages.markup.comment,
			 *     // tokens after 'comment'
			 * });
			 * ```
			 *
			 * ## Limitations
			 *
			 * The main problem `insertBefore` has to solve is iteration order. Since ES2015, the iteration order for object
			 * properties is guaranteed to be the insertion order (except for integer keys) but some browsers behave
			 * differently when keys are deleted and re-inserted. So `insertBefore` can't be implemented by temporarily
			 * deleting properties which is necessary to insert at arbitrary positions.
			 *
			 * To solve this problem, `insertBefore` doesn't actually insert the given tokens into the target object.
			 * Instead, it will create a new object and replace all references to the target object with the new one. This
			 * can be done without temporarily deleting properties, so the iteration order is well-defined.
			 *
			 * However, only references that can be reached from `Prism.languages` or `insert` will be replaced. I.e. if
			 * you hold the target object in a variable, then the value of the variable will not change.
			 *
			 * ```js
			 * var oldMarkup = Prism.languages.markup;
			 * var newMarkup = Prism.languages.insertBefore('markup', 'comment', { ... });
			 *
			 * assert(oldMarkup !== Prism.languages.markup);
			 * assert(newMarkup === Prism.languages.markup);
			 * ```
			 *
			 * @param {string} inside The property of `root` (e.g. a language id in `Prism.languages`) that contains the
			 * object to be modified.
			 * @param {string} before The key to insert before.
			 * @param {Grammar} insert An object containing the key-value pairs to be inserted.
			 * @param {Object<string, any>} [root] The object containing `inside`, i.e. the object that contains the
			 * object to be modified.
			 *
			 * Defaults to `Prism.languages`.
			 * @returns {Grammar} The new grammar object.
			 * @public
			 */
			insertBefore: function (inside, before, insert, root) {
				root = root || /** @type {any} */ (_.languages);
				var grammar = root[inside];
				/** @type {Grammar} */
				var ret = {};

				for (var token in grammar) {
					if (grammar.hasOwnProperty(token)) {

						if (token == before) {
							for (var newToken in insert) {
								if (insert.hasOwnProperty(newToken)) {
									ret[newToken] = insert[newToken];
								}
							}
						}

						// Do not insert token which also occur in insert. See #1525
						if (!insert.hasOwnProperty(token)) {
							ret[token] = grammar[token];
						}
					}
				}

				var old = root[inside];
				root[inside] = ret;

				// Update references in other language definitions
				_.languages.DFS(_.languages, function (key, value) {
					if (value === old && key != inside) {
						this[key] = ret;
					}
				});

				return ret;
			},

			// Traverse a language definition with Depth First Search
			DFS: function DFS(o, callback, type, visited) {
				visited = visited || {};

				var objId = _.util.objId;

				for (var i in o) {
					if (o.hasOwnProperty(i)) {
						callback.call(o, i, o[i], type || i);

						var property = o[i];
						var propertyType = _.util.type(property);

						if (propertyType === 'Object' && !visited[objId(property)]) {
							visited[objId(property)] = true;
							DFS(property, callback, null, visited);
						} else if (propertyType === 'Array' && !visited[objId(property)]) {
							visited[objId(property)] = true;
							DFS(property, callback, i, visited);
						}
					}
				}
			}
		},

		plugins: {},

		/**
		 * This is the most high-level function in Prism’s API.
		 * It fetches all the elements that have a `.language-xxxx` class and then calls {@link Prism.highlightElement} on
		 * each one of them.
		 *
		 * This is equivalent to `Prism.highlightAllUnder(document, async, callback)`.
		 *
		 * @param {boolean} [async=false] Same as in {@link Prism.highlightAllUnder}.
		 * @param {HighlightCallback} [callback] Same as in {@link Prism.highlightAllUnder}.
		 * @memberof Prism
		 * @public
		 */
		highlightAll: function (async, callback) {
			_.highlightAllUnder(document, async, callback);
		},

		/**
		 * Fetches all the descendants of `container` that have a `.language-xxxx` class and then calls
		 * {@link Prism.highlightElement} on each one of them.
		 *
		 * The following hooks will be run:
		 * 1. `before-highlightall`
		 * 2. `before-all-elements-highlight`
		 * 3. All hooks of {@link Prism.highlightElement} for each element.
		 *
		 * @param {ParentNode} container The root element, whose descendants that have a `.language-xxxx` class will be highlighted.
		 * @param {boolean} [async=false] Whether each element is to be highlighted asynchronously using Web Workers.
		 * @param {HighlightCallback} [callback] An optional callback to be invoked on each element after its highlighting is done.
		 * @memberof Prism
		 * @public
		 */
		highlightAllUnder: function (container, async, callback) {
			var env = {
				callback: callback,
				container: container,
				selector: 'code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code'
			};

			_.hooks.run('before-highlightall', env);

			env.elements = Array.prototype.slice.apply(env.container.querySelectorAll(env.selector));

			_.hooks.run('before-all-elements-highlight', env);

			for (var i = 0, element; (element = env.elements[i++]);) {
				_.highlightElement(element, async === true, env.callback);
			}
		},

		/**
		 * Highlights the code inside a single element.
		 *
		 * The following hooks will be run:
		 * 1. `before-sanity-check`
		 * 2. `before-highlight`
		 * 3. All hooks of {@link Prism.highlight}. These hooks will be run by an asynchronous worker if `async` is `true`.
		 * 4. `before-insert`
		 * 5. `after-highlight`
		 * 6. `complete`
		 *
		 * Some the above hooks will be skipped if the element doesn't contain any text or there is no grammar loaded for
		 * the element's language.
		 *
		 * @param {Element} element The element containing the code.
		 * It must have a class of `language-xxxx` to be processed, where `xxxx` is a valid language identifier.
		 * @param {boolean} [async=false] Whether the element is to be highlighted asynchronously using Web Workers
		 * to improve performance and avoid blocking the UI when highlighting very large chunks of code. This option is
		 * [disabled by default](https://prismjs.com/faq.html#why-is-asynchronous-highlighting-disabled-by-default).
		 *
		 * Note: All language definitions required to highlight the code must be included in the main `prism.js` file for
		 * asynchronous highlighting to work. You can build your own bundle on the
		 * [Download page](https://prismjs.com/download.html).
		 * @param {HighlightCallback} [callback] An optional callback to be invoked after the highlighting is done.
		 * Mostly useful when `async` is `true`, since in that case, the highlighting is done asynchronously.
		 * @memberof Prism
		 * @public
		 */
		highlightElement: function (element, async, callback) {
			// Find language
			var language = _.util.getLanguage(element);
			var grammar = _.languages[language];

			// Set language on the element, if not present
			element.className = element.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;

			// Set language on the parent, for styling
			var parent = element.parentElement;
			if (parent && parent.nodeName.toLowerCase() === 'pre') {
				parent.className = parent.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;
			}

			var code = element.textContent;

			var env = {
				element: element,
				language: language,
				grammar: grammar,
				code: code
			};

			function insertHighlightedCode(highlightedCode) {
				env.highlightedCode = highlightedCode;

				_.hooks.run('before-insert', env);

				env.element.innerHTML = env.highlightedCode;

				_.hooks.run('after-highlight', env);
				_.hooks.run('complete', env);
				callback && callback.call(env.element);
			}

			_.hooks.run('before-sanity-check', env);

			// plugins may change/add the parent/element
			parent = env.element.parentElement;
			if (parent && parent.nodeName.toLowerCase() === 'pre' && !parent.hasAttribute('tabindex')) {
				parent.setAttribute('tabindex', '0');
			}

			if (!env.code) {
				_.hooks.run('complete', env);
				callback && callback.call(env.element);
				return;
			}

			_.hooks.run('before-highlight', env);

			if (!env.grammar) {
				insertHighlightedCode(_.util.encode(env.code));
				return;
			}

			if (async && _self.Worker) {
				var worker = new Worker(_.filename);

				worker.onmessage = function (evt) {
					insertHighlightedCode(evt.data);
				};

				worker.postMessage(JSON.stringify({
					language: env.language,
					code: env.code,
					immediateClose: true
				}));
			} else {
				insertHighlightedCode(_.highlight(env.code, env.grammar, env.language));
			}
		},

		/**
		 * Low-level function, only use if you know what you’re doing. It accepts a string of text as input
		 * and the language definitions to use, and returns a string with the HTML produced.
		 *
		 * The following hooks will be run:
		 * 1. `before-tokenize`
		 * 2. `after-tokenize`
		 * 3. `wrap`: On each {@link Token}.
		 *
		 * @param {string} text A string with the code to be highlighted.
		 * @param {Grammar} grammar An object containing the tokens to use.
		 *
		 * Usually a language definition like `Prism.languages.markup`.
		 * @param {string} language The name of the language definition passed to `grammar`.
		 * @returns {string} The highlighted HTML.
		 * @memberof Prism
		 * @public
		 * @example
		 * Prism.highlight('var foo = true;', Prism.languages.javascript, 'javascript');
		 */
		highlight: function (text, grammar, language) {
			var env = {
				code: text,
				grammar: grammar,
				language: language
			};
			_.hooks.run('before-tokenize', env);
			env.tokens = _.tokenize(env.code, env.grammar);
			_.hooks.run('after-tokenize', env);
			return Token.stringify(_.util.encode(env.tokens), env.language);
		},

		/**
		 * This is the heart of Prism, and the most low-level function you can use. It accepts a string of text as input
		 * and the language definitions to use, and returns an array with the tokenized code.
		 *
		 * When the language definition includes nested tokens, the function is called recursively on each of these tokens.
		 *
		 * This method could be useful in other contexts as well, as a very crude parser.
		 *
		 * @param {string} text A string with the code to be highlighted.
		 * @param {Grammar} grammar An object containing the tokens to use.
		 *
		 * Usually a language definition like `Prism.languages.markup`.
		 * @returns {TokenStream} An array of strings and tokens, a token stream.
		 * @memberof Prism
		 * @public
		 * @example
		 * let code = `var foo = 0;`;
		 * let tokens = Prism.tokenize(code, Prism.languages.javascript);
		 * tokens.forEach(token => {
		 *     if (token instanceof Prism.Token && token.type === 'number') {
		 *         console.log(`Found numeric literal: ${token.content}`);
		 *     }
		 * });
		 */
		tokenize: function (text, grammar) {
			var rest = grammar.rest;
			if (rest) {
				for (var token in rest) {
					grammar[token] = rest[token];
				}

				delete grammar.rest;
			}

			var tokenList = new LinkedList();
			addAfter(tokenList, tokenList.head, text);

			matchGrammar(text, tokenList, grammar, tokenList.head, 0);

			return toArray(tokenList);
		},

		/**
		 * @namespace
		 * @memberof Prism
		 * @public
		 */
		hooks: {
			all: {},

			/**
			 * Adds the given callback to the list of callbacks for the given hook.
			 *
			 * The callback will be invoked when the hook it is registered for is run.
			 * Hooks are usually directly run by a highlight function but you can also run hooks yourself.
			 *
			 * One callback function can be registered to multiple hooks and the same hook multiple times.
			 *
			 * @param {string} name The name of the hook.
			 * @param {HookCallback} callback The callback function which is given environment variables.
			 * @public
			 */
			add: function (name, callback) {
				var hooks = _.hooks.all;

				hooks[name] = hooks[name] || [];

				hooks[name].push(callback);
			},

			/**
			 * Runs a hook invoking all registered callbacks with the given environment variables.
			 *
			 * Callbacks will be invoked synchronously and in the order in which they were registered.
			 *
			 * @param {string} name The name of the hook.
			 * @param {Object<string, any>} env The environment variables of the hook passed to all callbacks registered.
			 * @public
			 */
			run: function (name, env) {
				var callbacks = _.hooks.all[name];

				if (!callbacks || !callbacks.length) {
					return;
				}

				for (var i = 0, callback; (callback = callbacks[i++]);) {
					callback(env);
				}
			}
		},

		Token: Token
	};
	_self.Prism = _;


	// Typescript note:
	// The following can be used to import the Token type in JSDoc:
	//
	//   @typedef {InstanceType<import("./prism-core")["Token"]>} Token

	/**
	 * Creates a new token.
	 *
	 * @param {string} type See {@link Token#type type}
	 * @param {string | TokenStream} content See {@link Token#content content}
	 * @param {string|string[]} [alias] The alias(es) of the token.
	 * @param {string} [matchedStr=""] A copy of the full string this token was created from.
	 * @class
	 * @global
	 * @public
	 */
	function Token(type, content, alias, matchedStr) {
		/**
		 * The type of the token.
		 *
		 * This is usually the key of a pattern in a {@link Grammar}.
		 *
		 * @type {string}
		 * @see GrammarToken
		 * @public
		 */
		this.type = type;
		/**
		 * The strings or tokens contained by this token.
		 *
		 * This will be a token stream if the pattern matched also defined an `inside` grammar.
		 *
		 * @type {string | TokenStream}
		 * @public
		 */
		this.content = content;
		/**
		 * The alias(es) of the token.
		 *
		 * @type {string|string[]}
		 * @see GrammarToken
		 * @public
		 */
		this.alias = alias;
		// Copy of the full string this token was created from
		this.length = (matchedStr || '').length | 0;
	}

	/**
	 * A token stream is an array of strings and {@link Token Token} objects.
	 *
	 * Token streams have to fulfill a few properties that are assumed by most functions (mostly internal ones) that process
	 * them.
	 *
	 * 1. No adjacent strings.
	 * 2. No empty strings.
	 *
	 *    The only exception here is the token stream that only contains the empty string and nothing else.
	 *
	 * @typedef {Array<string | Token>} TokenStream
	 * @global
	 * @public
	 */

	/**
	 * Converts the given token or token stream to an HTML representation.
	 *
	 * The following hooks will be run:
	 * 1. `wrap`: On each {@link Token}.
	 *
	 * @param {string | Token | TokenStream} o The token or token stream to be converted.
	 * @param {string} language The name of current language.
	 * @returns {string} The HTML representation of the token or token stream.
	 * @memberof Token
	 * @static
	 */
	Token.stringify = function stringify(o, language) {
		if (typeof o == 'string') {
			return o;
		}
		if (Array.isArray(o)) {
			var s = '';
			o.forEach(function (e) {
				s += stringify(e, language);
			});
			return s;
		}

		var env = {
			type: o.type,
			content: stringify(o.content, language),
			tag: 'span',
			classes: ['token', o.type],
			attributes: {},
			language: language
		};

		var aliases = o.alias;
		if (aliases) {
			if (Array.isArray(aliases)) {
				Array.prototype.push.apply(env.classes, aliases);
			} else {
				env.classes.push(aliases);
			}
		}

		_.hooks.run('wrap', env);

		var attributes = '';
		for (var name in env.attributes) {
			attributes += ' ' + name + '="' + (env.attributes[name] || '').replace(/"/g, '&quot;') + '"';
		}

		return '<' + env.tag + ' class="' + env.classes.join(' ') + '"' + attributes + '>' + env.content + '</' + env.tag + '>';
	};

	/**
	 * @param {RegExp} pattern
	 * @param {number} pos
	 * @param {string} text
	 * @param {boolean} lookbehind
	 * @returns {RegExpExecArray | null}
	 */
	function matchPattern(pattern, pos, text, lookbehind) {
		pattern.lastIndex = pos;
		var match = pattern.exec(text);
		if (match && lookbehind && match[1]) {
			// change the match to remove the text matched by the Prism lookbehind group
			var lookbehindLength = match[1].length;
			match.index += lookbehindLength;
			match[0] = match[0].slice(lookbehindLength);
		}
		return match;
	}

	/**
	 * @param {string} text
	 * @param {LinkedList<string | Token>} tokenList
	 * @param {any} grammar
	 * @param {LinkedListNode<string | Token>} startNode
	 * @param {number} startPos
	 * @param {RematchOptions} [rematch]
	 * @returns {void}
	 * @private
	 *
	 * @typedef RematchOptions
	 * @property {string} cause
	 * @property {number} reach
	 */
	function matchGrammar(text, tokenList, grammar, startNode, startPos, rematch) {
		for (var token in grammar) {
			if (!grammar.hasOwnProperty(token) || !grammar[token]) {
				continue;
			}

			var patterns = grammar[token];
			patterns = Array.isArray(patterns) ? patterns : [patterns];

			for (var j = 0; j < patterns.length; ++j) {
				if (rematch && rematch.cause == token + ',' + j) {
					return;
				}

				var patternObj = patterns[j];
				var inside = patternObj.inside;
				var lookbehind = !!patternObj.lookbehind;
				var greedy = !!patternObj.greedy;
				var alias = patternObj.alias;

				if (greedy && !patternObj.pattern.global) {
					// Without the global flag, lastIndex won't work
					var flags = patternObj.pattern.toString().match(/[imsuy]*$/)[0];
					patternObj.pattern = RegExp(patternObj.pattern.source, flags + 'g');
				}

				/** @type {RegExp} */
				var pattern = patternObj.pattern || patternObj;

				for ( // iterate the token list and keep track of the current token/string position
					var currentNode = startNode.next, pos = startPos;
					currentNode !== tokenList.tail;
					pos += currentNode.value.length, currentNode = currentNode.next
				) {

					if (rematch && pos >= rematch.reach) {
						break;
					}

					var str = currentNode.value;

					if (tokenList.length > text.length) {
						// Something went terribly wrong, ABORT, ABORT!
						return;
					}

					if (str instanceof Token) {
						continue;
					}

					var removeCount = 1; // this is the to parameter of removeBetween
					var match;

					if (greedy) {
						match = matchPattern(pattern, pos, text, lookbehind);
						if (!match) {
							break;
						}

						var from = match.index;
						var to = match.index + match[0].length;
						var p = pos;

						// find the node that contains the match
						p += currentNode.value.length;
						while (from >= p) {
							currentNode = currentNode.next;
							p += currentNode.value.length;
						}
						// adjust pos (and p)
						p -= currentNode.value.length;
						pos = p;

						// the current node is a Token, then the match starts inside another Token, which is invalid
						if (currentNode.value instanceof Token) {
							continue;
						}

						// find the last node which is affected by this match
						for (
							var k = currentNode;
							k !== tokenList.tail && (p < to || typeof k.value === 'string');
							k = k.next
						) {
							removeCount++;
							p += k.value.length;
						}
						removeCount--;

						// replace with the new match
						str = text.slice(pos, p);
						match.index -= pos;
					} else {
						match = matchPattern(pattern, 0, str, lookbehind);
						if (!match) {
							continue;
						}
					}

					// eslint-disable-next-line no-redeclare
					var from = match.index;
					var matchStr = match[0];
					var before = str.slice(0, from);
					var after = str.slice(from + matchStr.length);

					var reach = pos + str.length;
					if (rematch && reach > rematch.reach) {
						rematch.reach = reach;
					}

					var removeFrom = currentNode.prev;

					if (before) {
						removeFrom = addAfter(tokenList, removeFrom, before);
						pos += before.length;
					}

					removeRange(tokenList, removeFrom, removeCount);

					var wrapped = new Token(token, inside ? _.tokenize(matchStr, inside) : matchStr, alias, matchStr);
					currentNode = addAfter(tokenList, removeFrom, wrapped);

					if (after) {
						addAfter(tokenList, currentNode, after);
					}

					if (removeCount > 1) {
						// at least one Token object was removed, so we have to do some rematching
						// this can only happen if the current pattern is greedy

						/** @type {RematchOptions} */
						var nestedRematch = {
							cause: token + ',' + j,
							reach: reach
						};
						matchGrammar(text, tokenList, grammar, currentNode.prev, pos, nestedRematch);

						// the reach might have been extended because of the rematching
						if (rematch && nestedRematch.reach > rematch.reach) {
							rematch.reach = nestedRematch.reach;
						}
					}
				}
			}
		}
	}

	/**
	 * @typedef LinkedListNode
	 * @property {T} value
	 * @property {LinkedListNode<T> | null} prev The previous node.
	 * @property {LinkedListNode<T> | null} next The next node.
	 * @template T
	 * @private
	 */

	/**
	 * @template T
	 * @private
	 */
	function LinkedList() {
		/** @type {LinkedListNode<T>} */
		var head = { value: null, prev: null, next: null };
		/** @type {LinkedListNode<T>} */
		var tail = { value: null, prev: head, next: null };
		head.next = tail;

		/** @type {LinkedListNode<T>} */
		this.head = head;
		/** @type {LinkedListNode<T>} */
		this.tail = tail;
		this.length = 0;
	}

	/**
	 * Adds a new node with the given value to the list.
	 *
	 * @param {LinkedList<T>} list
	 * @param {LinkedListNode<T>} node
	 * @param {T} value
	 * @returns {LinkedListNode<T>} The added node.
	 * @template T
	 */
	function addAfter(list, node, value) {
		// assumes that node != list.tail && values.length >= 0
		var next = node.next;

		var newNode = { value: value, prev: node, next: next };
		node.next = newNode;
		next.prev = newNode;
		list.length++;

		return newNode;
	}
	/**
	 * Removes `count` nodes after the given node. The given node will not be removed.
	 *
	 * @param {LinkedList<T>} list
	 * @param {LinkedListNode<T>} node
	 * @param {number} count
	 * @template T
	 */
	function removeRange(list, node, count) {
		var next = node.next;
		for (var i = 0; i < count && next !== list.tail; i++) {
			next = next.next;
		}
		node.next = next;
		next.prev = node;
		list.length -= i;
	}
	/**
	 * @param {LinkedList<T>} list
	 * @returns {T[]}
	 * @template T
	 */
	function toArray(list) {
		var array = [];
		var node = list.head.next;
		while (node !== list.tail) {
			array.push(node.value);
			node = node.next;
		}
		return array;
	}


	if (!_self.document) {
		if (!_self.addEventListener) {
			// in Node.js
			return _;
		}

		if (!_.disableWorkerMessageHandler) {
			// In worker
			_self.addEventListener('message', function (evt) {
				var message = JSON.parse(evt.data);
				var lang = message.language;
				var code = message.code;
				var immediateClose = message.immediateClose;

				_self.postMessage(_.highlight(code, _.languages[lang], lang));
				if (immediateClose) {
					_self.close();
				}
			}, false);
		}

		return _;
	}

	// Get current script and highlight
	var script = _.util.currentScript();

	if (script) {
		_.filename = script.src;

		if (script.hasAttribute('data-manual')) {
			_.manual = true;
		}
	}

	function highlightAutomaticallyCallback() {
		if (!_.manual) {
			_.highlightAll();
		}
	}

	if (!_.manual) {
		// If the document state is "loading", then we'll use DOMContentLoaded.
		// If the document state is "interactive" and the prism.js script is deferred, then we'll also use the
		// DOMContentLoaded event because there might be some plugins or languages which have also been deferred and they
		// might take longer one animation frame to execute which can create a race condition where only some plugins have
		// been loaded when Prism.highlightAll() is executed, depending on how fast resources are loaded.
		// See https://github.com/PrismJS/prism/issues/2102
		var readyState = document.readyState;
		if (readyState === 'loading' || readyState === 'interactive' && script && script.defer) {
			document.addEventListener('DOMContentLoaded', highlightAutomaticallyCallback);
		} else {
			if (window.requestAnimationFrame) {
				window.requestAnimationFrame(highlightAutomaticallyCallback);
			} else {
				window.setTimeout(highlightAutomaticallyCallback, 16);
			}
		}
	}

	return _;

}(_self));

if (module.exports) {
	module.exports = Prism;
}

// hack for components to work correctly in node.js
if (typeof commonjsGlobal !== 'undefined') {
	commonjsGlobal.Prism = Prism;
}

// some additional documentation/types

/**
 * The expansion of a simple `RegExp` literal to support additional properties.
 *
 * @typedef GrammarToken
 * @property {RegExp} pattern The regular expression of the token.
 * @property {boolean} [lookbehind=false] If `true`, then the first capturing group of `pattern` will (effectively)
 * behave as a lookbehind group meaning that the captured text will not be part of the matched text of the new token.
 * @property {boolean} [greedy=false] Whether the token is greedy.
 * @property {string|string[]} [alias] An optional alias or list of aliases.
 * @property {Grammar} [inside] The nested grammar of this token.
 *
 * The `inside` grammar will be used to tokenize the text value of each token of this kind.
 *
 * This can be used to make nested and even recursive language definitions.
 *
 * Note: This can cause infinite recursion. Be careful when you embed different languages or even the same language into
 * each another.
 * @global
 * @public
 */

/**
 * @typedef Grammar
 * @type {Object<string, RegExp | GrammarToken | Array<RegExp | GrammarToken>>}
 * @property {Grammar} [rest] An optional grammar object that will be appended to this grammar.
 * @global
 * @public
 */

/**
 * A function which will invoked after an element was successfully highlighted.
 *
 * @callback HighlightCallback
 * @param {Element} element The element successfully highlighted.
 * @returns {void}
 * @global
 * @public
 */

/**
 * @callback HookCallback
 * @param {Object<string, any>} env The environment variables of the hook.
 * @returns {void}
 * @global
 * @public
 */


/* **********************************************
     Begin prism-markup.js
********************************************** */

Prism.languages.markup = {
	'comment': /<!--[\s\S]*?-->/,
	'prolog': /<\?[\s\S]+?\?>/,
	'doctype': {
		// https://www.w3.org/TR/xml/#NT-doctypedecl
		pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i,
		greedy: true,
		inside: {
			'internal-subset': {
				pattern: /(^[^\[]*\[)[\s\S]+(?=\]>$)/,
				lookbehind: true,
				greedy: true,
				inside: null // see below
			},
			'string': {
				pattern: /"[^"]*"|'[^']*'/,
				greedy: true
			},
			'punctuation': /^<!|>$|[[\]]/,
			'doctype-tag': /^DOCTYPE/,
			'name': /[^\s<>'"]+/
		}
	},
	'cdata': /<!\[CDATA\[[\s\S]*?\]\]>/i,
	'tag': {
		pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/,
		greedy: true,
		inside: {
			'tag': {
				pattern: /^<\/?[^\s>\/]+/,
				inside: {
					'punctuation': /^<\/?/,
					'namespace': /^[^\s>\/:]+:/
				}
			},
			'special-attr': [],
			'attr-value': {
				pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
				inside: {
					'punctuation': [
						{
							pattern: /^=/,
							alias: 'attr-equals'
						},
						/"|'/
					]
				}
			},
			'punctuation': /\/?>/,
			'attr-name': {
				pattern: /[^\s>\/]+/,
				inside: {
					'namespace': /^[^\s>\/:]+:/
				}
			}

		}
	},
	'entity': [
		{
			pattern: /&[\da-z]{1,8};/i,
			alias: 'named-entity'
		},
		/&#x?[\da-f]{1,8};/i
	]
};

Prism.languages.markup['tag'].inside['attr-value'].inside['entity'] =
	Prism.languages.markup['entity'];
Prism.languages.markup['doctype'].inside['internal-subset'].inside = Prism.languages.markup;

// Plugin to make entity title show the real entity, idea by Roman Komarov
Prism.hooks.add('wrap', function (env) {

	if (env.type === 'entity') {
		env.attributes['title'] = env.content.replace(/&amp;/, '&');
	}
});

Object.defineProperty(Prism.languages.markup.tag, 'addInlined', {
	/**
	 * Adds an inlined language to markup.
	 *
	 * An example of an inlined language is CSS with `<style>` tags.
	 *
	 * @param {string} tagName The name of the tag that contains the inlined language. This name will be treated as
	 * case insensitive.
	 * @param {string} lang The language key.
	 * @example
	 * addInlined('style', 'css');
	 */
	value: function addInlined(tagName, lang) {
		var includedCdataInside = {};
		includedCdataInside['language-' + lang] = {
			pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i,
			lookbehind: true,
			inside: Prism.languages[lang]
		};
		includedCdataInside['cdata'] = /^<!\[CDATA\[|\]\]>$/i;

		var inside = {
			'included-cdata': {
				pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
				inside: includedCdataInside
			}
		};
		inside['language-' + lang] = {
			pattern: /[\s\S]+/,
			inside: Prism.languages[lang]
		};

		var def = {};
		def[tagName] = {
			pattern: RegExp(/(<__[^>]*>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function () { return tagName; }), 'i'),
			lookbehind: true,
			greedy: true,
			inside: inside
		};

		Prism.languages.insertBefore('markup', 'cdata', def);
	}
});
Object.defineProperty(Prism.languages.markup.tag, 'addAttribute', {
	/**
	 * Adds an pattern to highlight languages embedded in HTML attributes.
	 *
	 * An example of an inlined language is CSS with `style` attributes.
	 *
	 * @param {string} attrName The name of the tag that contains the inlined language. This name will be treated as
	 * case insensitive.
	 * @param {string} lang The language key.
	 * @example
	 * addAttribute('style', 'css');
	 */
	value: function (attrName, lang) {
		Prism.languages.markup.tag.inside['special-attr'].push({
			pattern: RegExp(
				/(^|["'\s])/.source + '(?:' + attrName + ')' + /\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))/.source,
				'i'
			),
			lookbehind: true,
			inside: {
				'attr-name': /^[^\s=]+/,
				'attr-value': {
					pattern: /=[\s\S]+/,
					inside: {
						'value': {
							pattern: /(^=\s*(["']|(?!["'])))\S[\s\S]*(?=\2$)/,
							lookbehind: true,
							alias: [lang, 'language-' + lang],
							inside: Prism.languages[lang]
						},
						'punctuation': [
							{
								pattern: /^=/,
								alias: 'attr-equals'
							},
							/"|'/
						]
					}
				}
			}
		});
	}
});

Prism.languages.html = Prism.languages.markup;
Prism.languages.mathml = Prism.languages.markup;
Prism.languages.svg = Prism.languages.markup;

Prism.languages.xml = Prism.languages.extend('markup', {});
Prism.languages.ssml = Prism.languages.xml;
Prism.languages.atom = Prism.languages.xml;
Prism.languages.rss = Prism.languages.xml;


/* **********************************************
     Begin prism-css.js
********************************************** */

(function (Prism) {

	var string = /(?:"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n])*')/;

	Prism.languages.css = {
		'comment': /\/\*[\s\S]*?\*\//,
		'atrule': {
			pattern: /@[\w-](?:[^;{\s]|\s+(?![\s{]))*(?:;|(?=\s*\{))/,
			inside: {
				'rule': /^@[\w-]+/,
				'selector-function-argument': {
					pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/,
					lookbehind: true,
					alias: 'selector'
				},
				'keyword': {
					pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
					lookbehind: true
				}
				// See rest below
			}
		},
		'url': {
			// https://drafts.csswg.org/css-values-3/#urls
			pattern: RegExp('\\burl\\((?:' + string.source + '|' + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ')\\)', 'i'),
			greedy: true,
			inside: {
				'function': /^url/i,
				'punctuation': /^\(|\)$/,
				'string': {
					pattern: RegExp('^' + string.source + '$'),
					alias: 'url'
				}
			}
		},
		'selector': {
			pattern: RegExp('(^|[{}\\s])[^{}\\s](?:[^{};"\'\\s]|\\s+(?![\\s{])|' + string.source + ')*(?=\\s*\\{)'),
			lookbehind: true
		},
		'string': {
			pattern: string,
			greedy: true
		},
		'property': {
			pattern: /(^|[^-\w\xA0-\uFFFF])(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i,
			lookbehind: true
		},
		'important': /!important\b/i,
		'function': {
			pattern: /(^|[^-a-z0-9])[-a-z0-9]+(?=\()/i,
			lookbehind: true
		},
		'punctuation': /[(){};:,]/
	};

	Prism.languages.css['atrule'].inside.rest = Prism.languages.css;

	var markup = Prism.languages.markup;
	if (markup) {
		markup.tag.addInlined('style', 'css');
		markup.tag.addAttribute('style', 'css');
	}

}(Prism));


/* **********************************************
     Begin prism-clike.js
********************************************** */

Prism.languages.clike = {
	'comment': [
		{
			pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
			lookbehind: true,
			greedy: true
		},
		{
			pattern: /(^|[^\\:])\/\/.*/,
			lookbehind: true,
			greedy: true
		}
	],
	'string': {
		pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
		greedy: true
	},
	'class-name': {
		pattern: /(\b(?:class|interface|extends|implements|trait|instanceof|new)\s+|\bcatch\s+\()[\w.\\]+/i,
		lookbehind: true,
		inside: {
			'punctuation': /[.\\]/
		}
	},
	'keyword': /\b(?:if|else|while|do|for|return|in|instanceof|function|new|try|throw|catch|finally|null|break|continue)\b/,
	'boolean': /\b(?:true|false)\b/,
	'function': /\b\w+(?=\()/,
	'number': /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i,
	'operator': /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
	'punctuation': /[{}[\];(),.:]/
};


/* **********************************************
     Begin prism-javascript.js
********************************************** */

Prism.languages.javascript = Prism.languages.extend('clike', {
	'class-name': [
		Prism.languages.clike['class-name'],
		{
			pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:prototype|constructor))/,
			lookbehind: true
		}
	],
	'keyword': [
		{
			pattern: /((?:^|\})\s*)catch\b/,
			lookbehind: true
		},
		{
			pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
			lookbehind: true
		},
	],
	// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
	'function': /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
	'number': /\b(?:(?:0[xX](?:[\dA-Fa-f](?:_[\dA-Fa-f])?)+|0[bB](?:[01](?:_[01])?)+|0[oO](?:[0-7](?:_[0-7])?)+)n?|(?:\d(?:_\d)?)+n|NaN|Infinity)\b|(?:\b(?:\d(?:_\d)?)+\.?(?:\d(?:_\d)?)*|\B\.(?:\d(?:_\d)?)+)(?:[Ee][+-]?(?:\d(?:_\d)?)+)?/,
	'operator': /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
});

Prism.languages.javascript['class-name'][0].pattern = /(\b(?:class|interface|extends|implements|instanceof|new)\s+)[\w.\\]+/;

Prism.languages.insertBefore('javascript', 'keyword', {
	'regex': {
		// eslint-disable-next-line regexp/no-dupe-characters-character-class
		pattern: /((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)\/(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/,
		lookbehind: true,
		greedy: true,
		inside: {
			'regex-source': {
				pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
				lookbehind: true,
				alias: 'language-regex',
				inside: Prism.languages.regex
			},
			'regex-delimiter': /^\/|\/$/,
			'regex-flags': /^[a-z]+$/,
		}
	},
	// This must be declared before keyword because we use "function" inside the look-forward
	'function-variable': {
		pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/,
		alias: 'function'
	},
	'parameter': [
		{
			pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/,
			lookbehind: true,
			inside: Prism.languages.javascript
		}
	],
	'constant': /\b[A-Z](?:[A-Z_]|\dx?)*\b/
});

Prism.languages.insertBefore('javascript', 'string', {
	'hashbang': {
		pattern: /^#!.*/,
		greedy: true,
		alias: 'comment'
	},
	'template-string': {
		pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/,
		greedy: true,
		inside: {
			'template-punctuation': {
				pattern: /^`|`$/,
				alias: 'string'
			},
			'interpolation': {
				pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/,
				lookbehind: true,
				inside: {
					'interpolation-punctuation': {
						pattern: /^\$\{|\}$/,
						alias: 'punctuation'
					},
					rest: Prism.languages.javascript
				}
			},
			'string': /[\s\S]+/
		}
	}
});

if (Prism.languages.markup) {
	Prism.languages.markup.tag.addInlined('script', 'javascript');

	// add attribute support for all DOM events.
	// https://developer.mozilla.org/en-US/docs/Web/Events#Standard_events
	Prism.languages.markup.tag.addAttribute(
		/on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source,
		'javascript'
	);
}

Prism.languages.js = Prism.languages.javascript;


/* **********************************************
     Begin prism-file-highlight.js
********************************************** */

(function () {

	if (typeof Prism === 'undefined' || typeof document === 'undefined') {
		return;
	}

	// https://developer.mozilla.org/en-US/docs/Web/API/Element/matches#Polyfill
	if (!Element.prototype.matches) {
		Element.prototype.matches = Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector;
	}

	var LOADING_MESSAGE = 'Loading…';
	var FAILURE_MESSAGE = function (status, message) {
		return '✖ Error ' + status + ' while fetching file: ' + message;
	};
	var FAILURE_EMPTY_MESSAGE = '✖ Error: File does not exist or is empty';

	var EXTENSIONS = {
		'js': 'javascript',
		'py': 'python',
		'rb': 'ruby',
		'ps1': 'powershell',
		'psm1': 'powershell',
		'sh': 'bash',
		'bat': 'batch',
		'h': 'c',
		'tex': 'latex'
	};

	var STATUS_ATTR = 'data-src-status';
	var STATUS_LOADING = 'loading';
	var STATUS_LOADED = 'loaded';
	var STATUS_FAILED = 'failed';

	var SELECTOR = 'pre[data-src]:not([' + STATUS_ATTR + '="' + STATUS_LOADED + '"])'
		+ ':not([' + STATUS_ATTR + '="' + STATUS_LOADING + '"])';

	var lang = /\blang(?:uage)?-([\w-]+)\b/i;

	/**
	 * Sets the Prism `language-xxxx` or `lang-xxxx` class to the given language.
	 *
	 * @param {HTMLElement} element
	 * @param {string} language
	 * @returns {void}
	 */
	function setLanguageClass(element, language) {
		var className = element.className;
		className = className.replace(lang, ' ') + ' language-' + language;
		element.className = className.replace(/\s+/g, ' ').trim();
	}


	Prism.hooks.add('before-highlightall', function (env) {
		env.selector += ', ' + SELECTOR;
	});

	Prism.hooks.add('before-sanity-check', function (env) {
		var pre = /** @type {HTMLPreElement} */ (env.element);
		if (pre.matches(SELECTOR)) {
			env.code = ''; // fast-path the whole thing and go to complete

			pre.setAttribute(STATUS_ATTR, STATUS_LOADING); // mark as loading

			// add code element with loading message
			var code = pre.appendChild(document.createElement('CODE'));
			code.textContent = LOADING_MESSAGE;

			var src = pre.getAttribute('data-src');

			var language = env.language;
			if (language === 'none') {
				// the language might be 'none' because there is no language set;
				// in this case, we want to use the extension as the language
				var extension = (/\.(\w+)$/.exec(src) || [, 'none'])[1];
				language = EXTENSIONS[extension] || extension;
			}

			// set language classes
			setLanguageClass(code, language);
			setLanguageClass(pre, language);

			// preload the language
			var autoloader = Prism.plugins.autoloader;
			if (autoloader) {
				autoloader.loadLanguages(language);
			}

			// load file
			var xhr = new XMLHttpRequest();
			xhr.open('GET', src, true);
			xhr.onreadystatechange = function () {
				if (xhr.readyState == 4) {
					if (xhr.status < 400 && xhr.responseText) {
						// mark as loaded
						pre.setAttribute(STATUS_ATTR, STATUS_LOADED);

						// highlight code
						code.textContent = xhr.responseText;
						Prism.highlightElement(code);

					} else {
						// mark as failed
						pre.setAttribute(STATUS_ATTR, STATUS_FAILED);

						if (xhr.status >= 400) {
							code.textContent = FAILURE_MESSAGE(xhr.status, xhr.statusText);
						} else {
							code.textContent = FAILURE_EMPTY_MESSAGE;
						}
					}
				}
			};
			xhr.send(null);
		}
	});

	Prism.plugins.fileHighlight = {
		/**
		 * Executes the File Highlight plugin for all matching `pre` elements under the given container.
		 *
		 * Note: Elements which are already loaded or currently loading will not be touched by this method.
		 *
		 * @param {ParentNode} [container=document]
		 */
		highlight: function highlight(container) {
			var elements = (container || document).querySelectorAll(SELECTOR);

			for (var i = 0, element; (element = elements[i++]);) {
				Prism.highlightElement(element);
			}
		}
	};

	var logged = false;
	/** @deprecated Use `Prism.plugins.fileHighlight.highlight` instead. */
	Prism.fileHighlight = function () {
		if (!logged) {
			console.warn('Prism.fileHighlight is deprecated. Use `Prism.plugins.fileHighlight.highlight` instead.');
			logged = true;
		}
		Prism.plugins.fileHighlight.highlight.apply(this, arguments);
	};

}());
});

var css_248z$2 = ".CodeWidget-module_code__25oay {\n  display: inline-block;\n  min-width: 50%;\n  border-radius: 3px !important; }\n\n.CodeWidget-module_selected__1Dya6 {\n  box-shadow: 0 0 0 3px #B4D5FF; }\n";
var styles$2 = {"code":"CodeWidget-module_code__25oay","selected":"CodeWidget-module_selected__1Dya6"};
styleInject(css_248z$2);

Prism.languages.clike = {
	'comment': [
		{
			pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
			lookbehind: true,
			greedy: true
		},
		{
			pattern: /(^|[^\\:])\/\/.*/,
			lookbehind: true,
			greedy: true
		}
	],
	'string': {
		pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
		greedy: true
	},
	'class-name': {
		pattern: /(\b(?:class|interface|extends|implements|trait|instanceof|new)\s+|\bcatch\s+\()[\w.\\]+/i,
		lookbehind: true,
		inside: {
			'punctuation': /[.\\]/
		}
	},
	'keyword': /\b(?:if|else|while|do|for|return|in|instanceof|function|new|try|throw|catch|finally|null|break|continue)\b/,
	'boolean': /\b(?:true|false)\b/,
	'function': /\b\w+(?=\()/,
	'number': /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i,
	'operator': /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
	'punctuation': /[{}[\];(),.:]/
};

Prism.languages.javascript = Prism.languages.extend('clike', {
	'class-name': [
		Prism.languages.clike['class-name'],
		{
			pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:prototype|constructor))/,
			lookbehind: true
		}
	],
	'keyword': [
		{
			pattern: /((?:^|\})\s*)catch\b/,
			lookbehind: true
		},
		{
			pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
			lookbehind: true
		},
	],
	// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
	'function': /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
	'number': /\b(?:(?:0[xX](?:[\dA-Fa-f](?:_[\dA-Fa-f])?)+|0[bB](?:[01](?:_[01])?)+|0[oO](?:[0-7](?:_[0-7])?)+)n?|(?:\d(?:_\d)?)+n|NaN|Infinity)\b|(?:\b(?:\d(?:_\d)?)+\.?(?:\d(?:_\d)?)*|\B\.(?:\d(?:_\d)?)+)(?:[Ee][+-]?(?:\d(?:_\d)?)+)?/,
	'operator': /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
});

Prism.languages.javascript['class-name'][0].pattern = /(\b(?:class|interface|extends|implements|instanceof|new)\s+)[\w.\\]+/;

Prism.languages.insertBefore('javascript', 'keyword', {
	'regex': {
		// eslint-disable-next-line regexp/no-dupe-characters-character-class
		pattern: /((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)\/(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/,
		lookbehind: true,
		greedy: true,
		inside: {
			'regex-source': {
				pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
				lookbehind: true,
				alias: 'language-regex',
				inside: Prism.languages.regex
			},
			'regex-delimiter': /^\/|\/$/,
			'regex-flags': /^[a-z]+$/,
		}
	},
	// This must be declared before keyword because we use "function" inside the look-forward
	'function-variable': {
		pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/,
		alias: 'function'
	},
	'parameter': [
		{
			pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/,
			lookbehind: true,
			inside: Prism.languages.javascript
		},
		{
			pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/,
			lookbehind: true,
			inside: Prism.languages.javascript
		}
	],
	'constant': /\b[A-Z](?:[A-Z_]|\dx?)*\b/
});

Prism.languages.insertBefore('javascript', 'string', {
	'hashbang': {
		pattern: /^#!.*/,
		greedy: true,
		alias: 'comment'
	},
	'template-string': {
		pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/,
		greedy: true,
		inside: {
			'template-punctuation': {
				pattern: /^`|`$/,
				alias: 'string'
			},
			'interpolation': {
				pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/,
				lookbehind: true,
				inside: {
					'interpolation-punctuation': {
						pattern: /^\$\{|\}$/,
						alias: 'punctuation'
					},
					rest: Prism.languages.javascript
				}
			},
			'string': /[\s\S]+/
		}
	}
});

if (Prism.languages.markup) {
	Prism.languages.markup.tag.addInlined('script', 'javascript');

	// add attribute support for all DOM events.
	// https://developer.mozilla.org/en-US/docs/Web/Events#Standard_events
	Prism.languages.markup.tag.addAttribute(
		/on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source,
		'javascript'
	);
}

Prism.languages.js = Prism.languages.javascript;

(function (Prism) {

	var javascript = Prism.util.clone(Prism.languages.javascript);

	var space = /(?:\s|\/\/.*(?!.)|\/\*(?:[^*]|\*(?!\/))\*\/)/.source;
	var braces = /(?:\{(?:\{(?:\{[^{}]*\}|[^{}])*\}|[^{}])*\})/.source;
	var spread = /(?:\{<S>*\.{3}(?:[^{}]|<BRACES>)*\})/.source;

	/**
	 * @param {string} source
	 * @param {string} [flags]
	 */
	function re(source, flags) {
		source = source
			.replace(/<S>/g, function () { return space; })
			.replace(/<BRACES>/g, function () { return braces; })
			.replace(/<SPREAD>/g, function () { return spread; });
		return RegExp(source, flags);
	}

	spread = re(spread).source;


	Prism.languages.jsx = Prism.languages.extend('markup', javascript);
	Prism.languages.jsx.tag.pattern = re(
		/<\/?(?:[\w.:-]+(?:<S>+(?:[\w.:$-]+(?:=(?:"(?:\\[\s\S]|[^\\"])*"|'(?:\\[\s\S]|[^\\'])*'|[^\s{'"/>=]+|<BRACES>))?|<SPREAD>))*<S>*\/?)?>/.source
	);

	Prism.languages.jsx.tag.inside['tag'].pattern = /^<\/?[^\s>\/]*/i;
	Prism.languages.jsx.tag.inside['attr-value'].pattern = /=(?!\{)(?:"(?:\\[\s\S]|[^\\"])*"|'(?:\\[\s\S]|[^\\'])*'|[^\s'">]+)/i;
	Prism.languages.jsx.tag.inside['tag'].inside['class-name'] = /^[A-Z]\w*(?:\.[A-Z]\w*)*$/;
	Prism.languages.jsx.tag.inside['comment'] = javascript['comment'];

	Prism.languages.insertBefore('inside', 'attr-name', {
		'spread': {
			pattern: re(/<SPREAD>/.source),
			inside: Prism.languages.jsx
		}
	}, Prism.languages.jsx.tag);

	Prism.languages.insertBefore('inside', 'special-attr', {
		'script': {
			// Allow for two levels of nesting
			pattern: re(/=<BRACES>/.source),
			inside: {
				'script-punctuation': {
					pattern: /^=(?=\{)/,
					alias: 'punctuation'
				},
				rest: Prism.languages.jsx
			},
			'alias': 'language-javascript'
		}
	}, Prism.languages.jsx.tag);

	// The following will handle plain text inside tags
	var stringifyToken = function (token) {
		if (!token) {
			return '';
		}
		if (typeof token === 'string') {
			return token;
		}
		if (typeof token.content === 'string') {
			return token.content;
		}
		return token.content.map(stringifyToken).join('');
	};

	var walkTokens = function (tokens) {
		var openedTags = [];
		for (var i = 0; i < tokens.length; i++) {
			var token = tokens[i];
			var notTagNorBrace = false;

			if (typeof token !== 'string') {
				if (token.type === 'tag' && token.content[0] && token.content[0].type === 'tag') {
					// We found a tag, now find its kind

					if (token.content[0].content[0].content === '</') {
						// Closing tag
						if (openedTags.length > 0 && openedTags[openedTags.length - 1].tagName === stringifyToken(token.content[0].content[1])) {
							// Pop matching opening tag
							openedTags.pop();
						}
					} else {
						if (token.content[token.content.length - 1].content === '/>') ; else {
							// Opening tag
							openedTags.push({
								tagName: stringifyToken(token.content[0].content[1]),
								openedBraces: 0
							});
						}
					}
				} else if (openedTags.length > 0 && token.type === 'punctuation' && token.content === '{') {

					// Here we might have entered a JSX context inside a tag
					openedTags[openedTags.length - 1].openedBraces++;

				} else if (openedTags.length > 0 && openedTags[openedTags.length - 1].openedBraces > 0 && token.type === 'punctuation' && token.content === '}') {

					// Here we might have left a JSX context inside a tag
					openedTags[openedTags.length - 1].openedBraces--;

				} else {
					notTagNorBrace = true;
				}
			}
			if (notTagNorBrace || typeof token === 'string') {
				if (openedTags.length > 0 && openedTags[openedTags.length - 1].openedBraces === 0) {
					// Here we are inside a tag, and not inside a JSX context.
					// That's plain text: drop any tokens matched.
					var plainText = stringifyToken(token);

					// And merge text with adjacent text
					if (i < tokens.length - 1 && (typeof tokens[i + 1] === 'string' || tokens[i + 1].type === 'plain-text')) {
						plainText += stringifyToken(tokens[i + 1]);
						tokens.splice(i + 1, 1);
					}
					if (i > 0 && (typeof tokens[i - 1] === 'string' || tokens[i - 1].type === 'plain-text')) {
						plainText = stringifyToken(tokens[i - 1]) + plainText;
						tokens.splice(i - 1, 1);
						i--;
					}

					tokens[i] = new Prism.Token('plain-text', plainText, null, plainText);
				}
			}

			if (token.content && typeof token.content !== 'string') {
				walkTokens(token.content);
			}
		}
	};

	Prism.hooks.add('after-tokenize', function (env) {
		if (env.language !== 'jsx' && env.language !== 'tsx') {
			return;
		}
		walkTokens(env.tokens);
	});

}(Prism));

(function (Prism) {

	Prism.languages.typescript = Prism.languages.extend('javascript', {
		'class-name': {
			pattern: /(\b(?:class|extends|implements|instanceof|interface|new|type)\s+)(?!keyof\b)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?:\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>)?/,
			lookbehind: true,
			greedy: true,
			inside: null // see below
		},
		'builtin': /\b(?:string|Function|any|number|boolean|Array|symbol|console|Promise|unknown|never)\b/,
	});

	// The keywords TypeScript adds to JavaScript
	Prism.languages.typescript.keyword.push(
		/\b(?:abstract|as|declare|implements|is|keyof|readonly|require)\b/,
		// keywords that have to be followed by an identifier
		// eslint-disable-next-line regexp/no-dupe-characters-character-class
		/\b(?:asserts|infer|interface|module|namespace|type)(?!\s*[^\s_${}*a-zA-Z\xA0-\uFFFF])/
	);

	// doesn't work with TS because TS is too complex
	delete Prism.languages.typescript['parameter'];

	// a version of typescript specifically for highlighting types
	var typeInside = Prism.languages.extend('typescript', {});
	delete typeInside['class-name'];

	Prism.languages.typescript['class-name'].inside = typeInside;

	Prism.languages.insertBefore('typescript', 'function', {
		'decorator': {
			pattern: /@[$\w\xA0-\uFFFF]+/,
			inside: {
				'at': {
					pattern: /^@/,
					alias: 'operator'
				},
				'function': /^[\s\S]+/
			}
		},
		'generic-function': {
			// e.g. foo<T extends "bar" | "baz">( ...
			pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>(?=\s*\()/,
			greedy: true,
			inside: {
				'function': /^#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*/,
				'generic': {
					pattern: /<[\s\S]+/, // everything after the first <
					alias: 'class-name',
					inside: typeInside
				}
			}
		}
	});

	Prism.languages.ts = Prism.languages.typescript;

}(Prism));

(function (Prism) {
	var typescript = Prism.util.clone(Prism.languages.typescript);
	Prism.languages.tsx = Prism.languages.extend('jsx', typescript);

	// This will prevent collisions between TSX tags and TS generic types.
	// Idea by https://github.com/karlhorky
	// Discussion: https://github.com/PrismJS/prism/issues/2594#issuecomment-710666928
	var tag = Prism.languages.tsx.tag;
	tag.pattern = RegExp(/(^|[^\w$]|(?=<\/))/.source + '(?:' + tag.pattern.source + ')', tag.pattern.flags);
	tag.lookbehind = true;
}(Prism));

var CodeWidget = function (_a) {
    var attributes = _a.attributes, children = _a.children, data = _a.data, setData = _a.setData, readOnly = _a.readOnly;
    var selected = useSelected();
    var focused = useFocused();
    useEffect(function () {
        setTimeout(function () {
            // ref.current && Prism.highlightAllUnder(ref.current);
            prism.highlightAll();
        });
    }, [data.code]);
    var onEdit = function () { return __awaiter(void 0, void 0, void 0, function () {
        var code;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (readOnly)
                        return [2 /*return*/];
                    return [4 /*yield*/, showModal({
                            getBody: function (_a) {
                                var closeModal = _a.closeModal;
                                return React.createElement(CodeEditor, { code: data.code, onSave: function (code) { return closeModal(code); } });
                            },
                            template: ModalTemplate.dialog
                        })];
                case 1:
                    code = _a.sent();
                    if (code && code.trim().length > 0) {
                        setData({ code: code });
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    return React.createElement("div", __assign({ className: styles$2.holder, onDoubleClick: onEdit }, attributes),
        React.createElement("pre", { className: [styles$2.code, 'language-js', selected && focused ? styles$2.selected : ' '].join(' '), contentEditable: false },
            React.createElement("code", { className: 'language-tsx' }, data.code)),
        children);
};

var CodePlugin = {
    id: "code",
    init: function (_a) {
        var editor = _a.editor;
        editor.voidElements.push(TYPE_CODE);
    },
    renderEdit: function (_a) {
        var data = _a.data, setData = _a.setData, attributes = _a.attributes, children = _a.children;
        if (data.type !== TYPE_CODE)
            return;
        return React.createElement(CodeWidget, { attributes: attributes, data: data, setData: setData, readOnly: false }, children);
    },
    renderView: function (_a) {
        var data = _a.data, setData = _a.setData, children = _a.children;
        if (data.type !== TYPE_CODE)
            return;
        return React.createElement(CodeWidget, { attributes: {}, data: data, setData: setData, readOnly: true }, children);
    },
    onInsert: function () {
        return __awaiter(this, void 0, void 0, function () {
            var code;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, showModal({
                            getBody: function (_a) {
                                var closeModal = _a.closeModal;
                                return React.createElement(CodeEditor, { code: '', onSave: function (code) { return closeModal(code); } });
                            },
                            template: ModalTemplate.dialog
                        })];
                    case 1:
                        code = _a.sent();
                        if (code) {
                            return [2 /*return*/, ({ type: TYPE_CODE, code: code })];
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
};

/**
 * Expose `isUrl`.
 */

var isUrl_1 = isUrl;

/**
 * RegExps.
 * A URL must match #1 and then at least one of #2/#3.
 * Use two levels of REs to avoid REDOS.
 */

var protocolAndDomainRE = /^(?:\w+:)?\/\/(\S+)$/;

var localhostDomainRE = /^localhost[\:?\d]*(?:[^\:?\d]\S*)?$/;
var nonLocalhostDomainRE = /^[^\s\.]+\.\S{2,}$/;

/**
 * Loosely validate a URL `string`.
 *
 * @param {String} string
 * @return {Boolean}
 */

function isUrl(string){
  if (typeof string !== 'string') {
    return false;
  }

  var match = string.match(protocolAndDomainRE);
  if (!match) {
    return false;
  }

  var everythingAfterProtocol = match[1];
  if (!everythingAfterProtocol) {
    return false;
  }

  if (localhostDomainRE.test(everythingAfterProtocol) ||
      nonLocalhostDomainRE.test(everythingAfterProtocol)) {
    return true;
  }

  return false;
}

var css_248z$1 = ".LinkDialog-module_fullScreen__1fS0W {\n  box-sizing: border-box;\n  position: fixed;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: rgba(0, 0, 0, 0.4); }\n\n.LinkDialog-module_dialog__1wsFt {\n  min-width: 30%;\n  padding: 1.5rem;\n  background-color: #fff;\n  border-radius: 4px;\n  box-shadow: 0 2px 26px rgba(0, 0, 0, 0.3), 0 0 0 1px rgba(0, 0, 0, 0.1);\n  display: flex;\n  flex-direction: column;\n  position: relative; }\n  .LinkDialog-module_dialog__1wsFt .LinkDialog-module_closeButton__24m9X {\n    display: inline-block;\n    position: absolute;\n    right: 0.5rem;\n    top: 0.5rem;\n    color: gray; }\n  .LinkDialog-module_dialog__1wsFt .LinkDialog-module_header__2ddSR {\n    font-weight: bold;\n    margin-bottom: 1rem; }\n  .LinkDialog-module_dialog__1wsFt .LinkDialog-module_body__3Mb8h {\n    display: flex;\n    flex-direction: column; }\n  .LinkDialog-module_dialog__1wsFt .LinkDialog-module_footer__14S11 {\n    text-align: left; }\n    .LinkDialog-module_dialog__1wsFt .LinkDialog-module_footer__14S11 button {\n      margin-right: 0.5rem;\n      border: 0;\n      padding: 0.5rem;\n      border-radius: 3px;\n      color: white;\n      background-color: #17bd17;\n      min-width: 5rem; }\n    .LinkDialog-module_dialog__1wsFt .LinkDialog-module_footer__14S11 button:hover {\n      background-color: #fff;\n      border: 1px solid #17bd17;\n      color: #17bd17;\n      cursor: pointer; }\n  .LinkDialog-module_dialog__1wsFt input {\n    padding: 6px 10px;\n    outline: 0;\n    border: 1px solid #dbdbdb;\n    margin-bottom: 1rem;\n    transition: border-color 0.15s; }\n  .LinkDialog-module_dialog__1wsFt input:focus {\n    color: #303030;\n    background-color: #fff;\n    border-color: #80bdff;\n    outline: 0;\n    box-shadow: 0 0 0 0.2rem rgba(0, 123, 255, 0.25); }\n";
var styles$1 = {"fullScreen":"LinkDialog-module_fullScreen__1fS0W","dialog":"LinkDialog-module_dialog__1wsFt","closeButton":"LinkDialog-module_closeButton__24m9X","header":"LinkDialog-module_header__2ddSR","body":"LinkDialog-module_body__3Mb8h","footer":"LinkDialog-module_footer__14S11"};
styleInject(css_248z$1);

var LinkDialog = function (_a) {
    var url = _a.url, closeModal = _a.closeModal;
    var _b = __read(useState(url), 2), link = _b[0], setLink = _b[1];
    var _c = __read(useState('link'), 2), text = _c[0], setText = _c[1];
    var onInsert = function () {
        closeModal({ link: link, text: text });
    };
    var onClose = function () { };
    return (React.createElement("div", { className: styles$1.fullScreen, onClick: onClose },
        React.createElement("div", { className: styles$1.dialog, onClick: function (e) { e.stopPropagation(); } },
            React.createElement("div", { className: styles$1.closeButton, onClick: onClose },
                React.createElement(CloseIcon, null)),
            React.createElement("div", { className: styles$1.header }, "ADD/EDIT LINK"),
            React.createElement("div", { className: styles$1.body },
                React.createElement("input", { value: link, onChange: function (e) { return setLink(e.target.value); }, placeholder: "Url" }),
                React.createElement("input", { value: text, onChange: function (e) { return setText(e.target.value); }, placeholder: "Link text" })),
            React.createElement("div", { className: styles$1.footer },
                React.createElement("button", { onClick: onInsert }, "Insert")))));
};

var unwrapLink = function (editor) {
    Transforms.unwrapNodes(editor, {
        match: function (n) {
            return !Editor.isEditor(n) && Element$1.isElement(n) && n.type === 'link';
        },
    });
};
var isLinkActive = function (editor) {
    var _a = __read(Editor.nodes(editor, {
        match: function (n) {
            return !Editor.isEditor(n) && Element$1.isElement(n) && n.type === 'link';
        },
    }), 1), link = _a[0];
    return !!link;
};
var wrapLink = function (editor, url, text) {
    if (isLinkActive(editor)) {
        unwrapLink(editor);
    }
    var selection = editor.selection;
    var isCollapsed = selection && Range.isCollapsed(selection);
    var link = {
        type: 'link',
        url: url
    };
    if (isCollapsed) {
        Transforms.insertNodes(editor, __assign(__assign({}, link), { children: [{ text: text }] }));
    }
    else {
        Transforms.wrapNodes(editor, __assign(__assign({}, link), { children: [] }), { split: true });
        Transforms.collapse(editor, { edge: 'end' });
    }
};
var LinkPlugin = {
    id: "link",
    init: function (_a) {
        var editor = _a.editor;
        var insertData = editor.insertData, isInline = editor.isInline;
        editor.insertData = function (data) {
            var text = data.getData('text/plain');
            if (text && text.length >= 7 && isUrl_1(text)) {
                showDialog(text);
            }
            else {
                insertData(data);
            }
        };
        editor.isInline = function (element) {
            return element.type === TYPE_LINK ? true : isInline(element);
        };
        function showDialog(initialUrl) {
            return __awaiter(this, void 0, void 0, function () {
                var editorSelection, _a, link, text;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            editorSelection = editor.selection;
                            return [4 /*yield*/, showModal({
                                    getBody: function (_a) {
                                        var closeModal = _a.closeModal;
                                        return React__default.createElement(LinkDialog, { closeModal: closeModal, url: initialUrl });
                                    }, template: ModalTemplate.dialog
                                })];
                        case 1:
                            _a = _b.sent(), link = _a.link, text = _a.text;
                            editor.selection = editorSelection;
                            ReactEditor.focus(editor);
                            setTimeout(function () {
                                wrapLink(editor, link, text || link);
                            });
                            return [2 /*return*/];
                    }
                });
            });
        }
    },
    renderEdit: function (_a) {
        var data = _a.data, attributes = _a.attributes, children = _a.children;
        var _b = data, type = _b.type, url = _b.url;
        if (type !== TYPE_LINK)
            return;
        return React__default.createElement("a", __assign({}, attributes, { href: url, target: "_blank" }), children);
    },
    renderView: function (_a) {
        var data = _a.data, attributes = _a.attributes, children = _a.children;
        var _b = data, type = _b.type, url = _b.url;
        if (type !== TYPE_LINK)
            return;
        return React__default.createElement("a", __assign({}, attributes, { href: url, target: "_blank" }), children);
    }
};

var TextFormatPlugin = {
    id: "format",
    renderEdit: function (_a) {
        var data = _a.data, attributes = _a.attributes, children = _a.children;
        var type = data.type;
        // It's mandatory to pass attributes and children values. They come from slatejs library
        switch (type) {
            case TYPE_BULLETED_LIST:
                return React.createElement("ul", __assign({}, attributes), children);
            case TYPE_H1:
                return React.createElement("h1", __assign({}, attributes), children);
            case TYPE_H2:
                return React.createElement("h2", __assign({}, attributes), children);
            case TYPE_H3:
                return React.createElement("h3", __assign({}, attributes), children);
            case TYPE_LIST_ITEM:
                return React.createElement("li", __assign({}, attributes), children);
            case TYPE_NUMBERED_LIST:
                return React.createElement("ol", __assign({}, attributes), children);
            default:
                return React.createElement("div", __assign({}, attributes), children);
        }
    }
};
var LeafElement = function (_a) {
    var attributes = _a.attributes, children = _a.children, leaf = _a.leaf;
    if (leaf.bold) {
        children = React.createElement("strong", __assign({}, attributes), children);
    }
    if (leaf.italic) {
        children = React.createElement("em", __assign({}, attributes), children);
    }
    if (leaf.underline) {
        children = React.createElement("u", __assign({}, attributes), children);
    }
    return React.createElement("span", __assign({}, attributes), children);
};

var plugins = [ImagePlugin, CodePlugin, LinkPlugin, TextFormatPlugin];
var getStandardPlugins = function () { return plugins; };

var css_248z = ".EditorToolbar-module_component__3dfsx {\n  box-sizing: border-box;\n  display: flex;\n  align-items: center;\n  margin: 0;\n  padding: 0; }\n\n.EditorToolbar-module_toolbarIcon__1LSSc {\n  position: relative;\n  display: flex;\n  width: 32px;\n  height: 32px;\n  justify-content: center;\n  align-items: center; }\n\n.EditorToolbar-module_toolbarIcon__1LSSc.EditorToolbar-module_active__3YoR6 svg {\n  border-radius: 2px;\n  box-shadow: inset 0 0 2px 0 #696969; }\n\n.EditorToolbar-module_toolbarIcon__1LSSc:hover {\n  background-color: #e8e8e8; }\n\n.EditorToolbar-module_separator__2ltrU {\n  height: 20px;\n  border-left: 1px solid #c0c0c0;\n  padding-right: 1px;\n  margin-left: 1px; }\n";
var styles = {"component":"EditorToolbar-module_component__3dfsx","toolbarIcon":"EditorToolbar-module_toolbarIcon__1LSSc","active":"EditorToolbar-module_active__3YoR6","separator":"EditorToolbar-module_separator__2ltrU"};
styleInject(css_248z);

const isMarkActive = (editor, format) => {
    const marks = Editor.marks(editor);
    return marks ? marks[format] === true : false
};

const toggleMark = (editor, format) => {
    const isActive = isMarkActive(editor, format);

    if (isActive) {
        Editor.removeMark(editor, format);
    } else {
        Editor.addMark(editor, format, true);
    }
};

const isBlockActive = (editor, format) => {
    const iter = Editor.nodes(editor, {
        match: n =>
            !Editor.isEditor(n) && Element$1.isElement(n) && n.type === format,
    });
    const match = iter.next().value;
    return !!match
};

const LIST_TYPES = [TYPE_NUMBERED_LIST, TYPE_BULLETED_LIST];

const toggleBlock = (editor, format) => {
    const isActive = isBlockActive(editor, format);
    const isList = LIST_TYPES.includes(format);

    Transforms.unwrapNodes(editor, {
        match: n =>
            LIST_TYPES.includes(
                !Editor.isEditor(n) && Element$1.isElement(n) && n.type
            ),
        split: true,
    });
    // FIXME
    //const newProperties: Partial<SlateElement> = {
    const newProperties = {
        type: isActive ? TYPE_PARAGRAPH : isList ? TYPE_LIST_ITEM : format,
    };
    Transforms.setNodes(editor, newProperties);

    if (!isActive && isList) {
        const block = { type: format, children: [] };
        Transforms.wrapNodes(editor, block);
    }
};

var getDefaultToolbar = function (editor, widgets) {
    var insertWidget = function (type) { return __awaiter(void 0, void 0, void 0, function () {
        var plugin, selection, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    plugin = widgets.find(function (o) { return o.id === type; });
                    if (!plugin) {
                        console.log('Plugin ', type, ' not found');
                        return [2 /*return*/];
                    }
                    selection = editor.selection;
                    return [4 /*yield*/, plugin.onInsert()];
                case 1:
                    data = _a.sent();
                    if (!data)
                        return [2 /*return*/];
                    editor.selection = selection;
                    return [2 /*return*/, Transforms.insertNodes(editor, __assign(__assign({}, data), { children: [{ text: '' }] }))];
            }
        });
    }); };
    var operations = {
        toggleH1: function () { return toggleBlock(editor, TYPE_H1); },
        toggleH2: function () { return toggleBlock(editor, TYPE_H2); },
        toggleH3: function () { return toggleBlock(editor, TYPE_H3); },
        toggleBold: function () { return toggleMark(editor, MARK_BOLD); },
        toggleUnderline: function () { return toggleMark(editor, MARK_UNDERLINE); },
        toggleItalic: function () { return toggleMark(editor, MARK_ITALIC); },
        // FIXME: multilevel list/bullet
        toggleList: function (level) { return toggleBlock(editor, TYPE_NUMBERED_LIST); },
        toggleBullet: function (level) { return toggleBlock(editor, TYPE_BULLETED_LIST); },
        isH1: function () { return isBlockActive(editor, TYPE_H1); },
        isH2: function () { return isBlockActive(editor, TYPE_H2); },
        isH3: function () { return isBlockActive(editor, TYPE_H3); },
        isInBold: function () { return isMarkActive(editor, MARK_BOLD); },
        isInItalic: function () { return isMarkActive(editor, MARK_ITALIC); },
        isInUnderline: function () { return isMarkActive(editor, MARK_UNDERLINE); },
    };
    return [
        {
            tooltip: "Header 1 (ctrl+alt+1)",
            icon: "h1",
            onClick: function () { return operations.toggleH1(); },
            isActive: function () { return operations.isH1(); }
        },
        {
            tooltip: "Header 2 (ctrl+alt+2)",
            icon: "h2",
            onClick: function () { return operations.toggleH2(); },
            isActive: function () { return operations.isH2(); }
        },
        {
            tooltip: "Header 3 (ctrl+alt+3)",
            icon: "h3",
            onClick: function () { return operations.toggleH3(); },
            isActive: function () { return operations.isH3(); }
        },
        "separator",
        {
            tooltip: "Bold (ctrl+b)",
            icon: "bold",
            onClick: function () { return operations.toggleBold(); },
            isActive: function () { return operations.isInBold(); }
        },
        {
            tooltip: "Italic (ctrl+i)",
            icon: "italic",
            onClick: function () { return operations.toggleItalic(); },
            isActive: function () { return operations.isInItalic(); }
        },
        {
            tooltip: "Underline (ctrl+u)",
            icon: "underline",
            onClick: function () { return operations.toggleUnderline(); },
            isActive: function () { return operations.isInUnderline(); }
        },
        "separator",
        {
            tooltip: "List",
            icon: "number",
            onClick: function () { return operations.toggleList(1); },
            isActive: function () { return false; }, //
        },
        {
            tooltip: "Bullet",
            icon: "bullet",
            onClick: function () { return operations.toggleBullet(1); },
            isActive: function () { return false; }, //
        },
        "separator",
        {
            tooltip: "Code (ctrl+/)",
            icon: "code",
            onClick: function () { return insertWidget('code'); },
            isActive: function () { return false; }
        },
        {
            tooltip: "Image",
            icon: "image",
            onClick: function () { return insertWidget('image'); },
            isActive: function () { return false; }
        }
    ];
};

function H1Icon(props) {
    return (React.createElement("svg", __assign({ style: {
            width: 24,
            height: 24,
        }, viewBox: "0 0 24 24" }, props),
        React.createElement("path", { fill: "currentColor", d: "M3 4h2v6h4V4h2v14H9v-6H5v6H3V4m11 14v-2h2V6.31l-2.5 1.44V5.44L16 4h2v12h2v2h-6z" })));
}

function H2Icon(props) {
    return (React.createElement("svg", __assign({ style: {
            width: 24,
            height: 24,
        }, viewBox: "0 0 24 24" }, props),
        React.createElement("path", { fill: "currentColor", d: "M3 4h2v6h4V4h2v14H9v-6H5v6H3V4m18 14h-6a2 2 0 01-2-2c0-.53.2-1 .54-1.36l4.87-5.23c.37-.36.59-.86.59-1.41a2 2 0 00-2-2 2 2 0 00-2 2h-2a4 4 0 014-4 4 4 0 014 4c0 1.1-.45 2.1-1.17 2.83L15 16h6v2z" })));
}

function H3Icon(props) {
    return (React.createElement("svg", __assign({ style: {
            width: 24,
            height: 24,
        }, viewBox: "0 0 24 24" }, props),
        React.createElement("path", { fill: "currentColor", d: "M3 4h2v6h4V4h2v14H9v-6H5v6H3V4m12 0h4a2 2 0 012 2v10a2 2 0 01-2 2h-4a2 2 0 01-2-2v-1h2v1h4v-4h-4v-2h4V6h-4v1h-2V6a2 2 0 012-2z" })));
}

function BoldIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M13.5 15.5H10v-3h3.5A1.5 1.5 0 0115 14a1.5 1.5 0 01-1.5 1.5m-3.5-9h3A1.5 1.5 0 0114.5 8 1.5 1.5 0 0113 9.5h-3m5.6 1.29c.97-.68 1.65-1.79 1.65-2.79 0-2.26-1.75-4-4-4H7v14h7.04c2.1 0 3.71-1.7 3.71-3.79 0-1.52-.86-2.82-2.15-3.42z" }));
}

function UnderlineIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M5 21h14v-2H5v2m7-4a6 6 0 006-6V3h-2.5v8a3.5 3.5 0 01-3.5 3.5A3.5 3.5 0 018.5 11V3H6v8a6 6 0 006 6z" }));
}

function ItalicIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M10 4v3h2.21l-3.42 8H6v3h8v-3h-2.21l3.42-8H18V4h-8z" }));
}

function CodeIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M14.6 16.6l4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4m-5.2 0L4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4z" }));
}

function QuoteIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M14 17h3l2-4V7h-6v6h3M6 17h3l2-4V7H5v6h3l-2 4z" }));
}

function ListIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M7 13v-2h14v2H7m0 6v-2h14v2H7M7 7V5h14v2H7M3 8V5H2V4h2v4H3m-1 9v-1h3v4H2v-1h2v-.5H3v-1h1V17H2m2.25-7a.75.75 0 01.75.75c0 .2-.08.39-.21.52L3.12 13H5v1H2v-.92L4 11H2v-1h2.25z" }));
}

function BulletIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M3 4h4v4H3V4m6 1v2h12V5H9m-6 5h4v4H3v-4m6 1v2h12v-2H9m-6 5h4v4H3v-4m6 1v2h12v-2H9" }));
}

function ImageIcon(props) {
    return React.createElement("svg", __assign({}, props, { style: {
            width: 24,
            height: 24
        }, viewBox: "0 0 24 24" }),
        React.createElement("path", { fill: "currentColor", d: "M19 19H5V5h14m0-2H5a2 2 0 00-2 2v14a2 2 0 002 2h14a2 2 0 002-2V5a2 2 0 00-2-2m-5.04 9.29l-2.75 3.54-1.96-2.36L6.5 17h11l-3.54-4.71z" }));
}

var EditorIcons = {
    'h1': H1Icon,
    'h2': H2Icon,
    'h3': H3Icon,
    'bold': BoldIcon,
    'underline': UnderlineIcon,
    'italic': ItalicIcon,
    'code': CodeIcon,
    'quote': QuoteIcon,
    'number': ListIcon,
    'bullet': BulletIcon,
    'image': ImageIcon
};

var ToolbarIcon = function (_a) {
    var icon = _a.icon, active = _a.active;
    var Icon = EditorIcons[icon] || QuoteIcon;
    var clx = [styles.toolbarIcon];
    active && clx.push(styles.active);
    return (React.createElement("div", { className: clx.join(' ') },
        React.createElement(Icon, null)));
};
var ToolbarButton = function (_a) {
    var tooltip = _a.tooltip, icon = _a.icon, onClick = _a.onClick, isActive = _a.isActive;
    var onMouseDownWrapper = useCallback(function (e) {
        e.stopPropagation();
        e.preventDefault();
        onClick && onClick();
    }, [onClick]);
    isActive = isActive || (function () { return false; });
    return (React.createElement("div", { title: tooltip, onMouseDown: onMouseDownWrapper },
        React.createElement(ToolbarIcon, { icon: icon, active: isActive() })));
};
var Separator = function () {
    return (React.createElement("div", { className: styles.separator }));
};
var EditorToolbar = function (_a) {
    var plugins = _a.plugins;
    var editor = useSlate();
    var options = getDefaultToolbar(editor, plugins);
    return (React.createElement("div", { className: styles.component }, options.map(function (options, i) {
        if (options === "separator")
            return React.createElement(Separator, { key: i });
        var params = __assign({}, options);
        return React.createElement(ToolbarButton, __assign({ key: i }, params));
    })));
};

var BlockElement = function (props) {
    var e_1, _a;
    var attributes = props.attributes, children = props.children, element = props.element, plugins = props.plugins;
    var editor = useSlate();
    var setData = function (data) {
        if (data === undefined) {
            editor.deleteForward('block');
        }
        else {
            var path = ReactEditor.findPath(editor, element);
            Transforms.setNodes(editor, data, { at: path });
        }
    };
    try {
        for (var plugins_1 = __values(plugins), plugins_1_1 = plugins_1.next(); !plugins_1_1.done; plugins_1_1 = plugins_1.next()) {
            var plugin = plugins_1_1.value;
            if (plugin.renderEdit) {
                var result = plugin.renderEdit({ data: element, setData: setData, attributes: attributes, children: children });
                if (result)
                    return result;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (plugins_1_1 && !plugins_1_1.done && (_a = plugins_1.return)) _a.call(plugins_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return React.createElement("div", null);
};
/** Render values as readonly. Note that slate is not used for rendering readonly */
var renderReadOnly = function (elms, plugins) {
    if (!elms)
        return [];
    return elms.map(function (elm, index) {
        var e_2, _a;
        var _b;
        if (elm.type || Array.isArray(elm.children)) {
            var children = renderReadOnly(elm.children, plugins);
            try {
                for (var _c = __values(plugins || []), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var plugin = _d.value;
                    var renderer = plugin.renderView || plugin.renderEdit;
                    var result = renderer && renderer({ data: elm, children: children });
                    if (result)
                        return React.createElement(React.Fragment, { key: index }, result);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return React.createElement("div", { key: index },
                "[Widget not supported, type=",
                elm.type,
                "]");
        }
        else {
            return React.createElement(LeafElement, { key: index, attributes: {}, children: (_b = elm) === null || _b === void 0 ? void 0 : _b.text, leaf: elm });
        }
    });
};

var GoleryEditable = function (_a) {
    var plugins = _a.plugins;
    var renderElement = useCallback(function (props) {
        return React.createElement(BlockElement, __assign({}, props, { plugins: plugins }), props.children);
    }, []);
    var renderLeaf = useCallback(function (props) {
        return React.createElement(LeafElement, __assign({}, props), props.children);
    }, []);
    return (React.createElement(Editable, { className: 'golery-editable', renderElement: renderElement, renderLeaf: renderLeaf }));
};

var EditorController = /** @class */ (function () {
    function EditorController(editor) {
        this.editor = editor;
    }
    EditorController.prototype.focus = function () {
        ReactEditor.focus(this.editor);
    };
    return EditorController;
}());

var withVoidElements = function (editor) {
    editor.voidElements = [];
    var isVoid = editor.isVoid;
    editor.isVoid = function (element) {
        if (element.type && editor.voidElements.includes(element.type)) {
            return true;
        }
        return isVoid(element);
    };
    return editor;
};
var getEmptyTextValue = function () { return ([{
        type: TYPE_PARAGRAPH,
        children: [{ text: "" }],
    }]); };
// This context pass list of plugins to GoleryEditable
var EditorPluginContext = React.createContext({ plugins: getStandardPlugins() });
var editorContext = { plugins: getStandardPlugins() };
var EditorContext = function (_a) {
    var children = _a.children, controllerRef = _a.controllerRef, value = _a.value, setValue = _a.setValue, plugins = _a.plugins;
    var _b = useMemo(function () {
        var e_1, _a;
        var editor = withVoidElements(withHistory(withReact(createEditor())));
        if (plugins) {
            try {
                for (var plugins_1 = __values(plugins), plugins_1_1 = plugins_1.next(); !plugins_1_1.done; plugins_1_1 = plugins_1.next()) {
                    var plugin = plugins_1_1.value;
                    (plugin === null || plugin === void 0 ? void 0 : plugin.init) && (plugin === null || plugin === void 0 ? void 0 : plugin.init({ editor: editor, controller: {} }));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (plugins_1_1 && !plugins_1_1.done && (_a = plugins_1.return)) _a.call(plugins_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return ({ linkPlugin: linkPlugin, editor: editor });
    }, []), linkPlugin = _b.linkPlugin, editor = _b.editor;
    useEffect(function () {
        controllerRef.current = new EditorController(editor);
    }, [editor]);
    var editorValue = Array.isArray(value) ? value : getEmptyTextValue();
    return (React.createElement(Slate, { editor: editor, value: editorValue, onChange: function (newValue) { return setValue(newValue); } },
        React.createElement(EditorPluginContext.Provider, { value: editorContext }, children)));
};

var GoleryEditor = function (_a) {
    var value = _a.value, setValue = _a.setValue, controllerRef = _a.controllerRef;
    var plugins = useMemo(function () { return getStandardPlugins(); }, []);
    return (React.createElement(EditorContext, { controllerRef: controllerRef, value: value, setValue: setValue, plugins: plugins },
        React.createElement(EditorToolbar, { plugins: plugins }),
        React.createElement(GoleryEditable, { plugins: plugins })));
};

/** Render text editor value as read only content.
 * Here, we don't use the Slate for render, just manually iterate through the value tree and render each of them
 * recursively */
var EditorReadOnly = function (_a) {
    var value = _a.value;
    var plugins = useMemo(function () { return getStandardPlugins(); }, []);
    return (React.createElement("div", { className: "readonlyRender" }, renderReadOnly(value, plugins)));
};

export { EditorController, EditorReadOnly, GoleryEditor };
//# sourceMappingURL=index.es.js.map
